



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>第三十七节、人脸检测MTCNN和人脸识别Facenet(附源码)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">第三十七节、人脸检测MTCNN和人脸识别Facenet(附源码)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 20:16:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在说到人脸检测我们首先会想到利用Harr特征提取和Adaboost分类器进行人脸检测(有兴趣的可以去一看这篇博客<a href="https://www.cnblogs.com/zyly/p/9410563.html" rel="external nofollow noreferrer">第九节、人脸检测之Haar分类器</a>)，其检测效果也是不错的，但是目前人脸检测的应用场景逐渐从室内演变到室外，从单一限定场景发展到广场、车站、地铁口等场景，人脸检测面临的要求越来越高，比如：人脸尺度多变、数量冗大、姿势多样包括俯拍人脸、戴帽子口罩等的遮挡、表情夸张、化妆伪装、光照条件恶劣、分辨率低甚至连肉眼都较难区分等。在这样复杂的环境下基于Haar特征的人脸检测表现的不尽人意。随着深度学习的发展，基于深度学习的人脸检测技术取得了巨大的成功，在这一节我们将会介绍MTCNN算法，它是基于卷积神经网络的一种高精度的实时人脸检测和对齐技术。</p>
<p>搭建人脸识别系统的第一步就是人脸检测，也就是在图片中找到人脸的位置。在这个过程中输入的是一张含有人脸的图像，输出的是所有人脸的矩形框。一般来说，人脸检测应该能够检测出图像中的所有人脸，不能有漏检，更不能有错检。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180925205645794-605826428.png" /></p>
<p>获得人脸之后，第二步我们要做的工作就是人脸对齐，由于原始图像中的人脸可能存在姿态、位置上的差异，为了之后的统一处理，我们要把人脸&ldquo;摆正&rdquo;。为此，需要检测人脸中的关键点，比如眼睛的位置、鼻子的位置、嘴巴的位置、脸的轮廓点等。根据这些关键点可以使用仿射变换将人脸统一校准，以消除姿势不同带来的误差。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180925210351889-806086561.png" /></p>
<h3>一 MTCNN算法结构</h3>
<p>MTCNN算法是一种基于深度学习的人脸检测和人脸对齐方法，它可以同时完成人脸检测和人脸对齐的任务，相比于传统的算法，它的性能更好，检测速度更快。</p>
<p>MTCNN算法包含三个子网络：Proposal Network(P-Net)、Refine Network(R-Net)、Output Network(O-Net)，这三个网络对人脸的处理依次从粗到细。</p>
<p>在使用这三个子网络之前，需要使用图像金字塔将原始图像缩放到不同的尺度，然后将不同尺度的图像送入这三个子网络中进行训练，目的是为了可以检测到不同大小的人脸，从而实现多尺度目标检测。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180925211839562-672597965.png" /></p>
<h4>1、P-Net网络</h4>
<p>P-Net的主要目的是为了生成一些候选框，我们通过使用P-Net网络，对图像金字塔图像上不同尺度下的图像的每一个$12\times{12}$区域都做一个人脸检测(实际上在使用卷积网络实现时，一般会把一张$h\times{w}$的图像送入P-Net中，最终得到的特征图每一点都对应着一个大小为$12\times{12}$的感受野，但是并没有遍历全一张图像每一个$12\times{12}$的图像)。</p>
<p>P-Net的输入是一个$12\times{12}\times{3}$的RGB图像，在训练的时候，该网络要判断这个$12\times{12}$的图像中是否存在人脸，并且给出人脸框的回归和人脸关键点定位；</p>
<p>在测试的时候输出只有$N$个边界框的4个坐标信息和score，当然这4个坐标信息已经使用网络的人脸框回归进行校正过了，score可以看做是分类的输出(即人脸的概率)：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180925212803256-2025246981.png" /></p>
<ul><li>网络的第一部分输出是用来判断该图像是否包含人脸，输出向量大小为$1\times{1}\times{2}$，也就是两个值，即图像是人脸的概率和图像不是人脸的概率。这两个值加起来严格等于1，之所以使用两个值来表示，是为了方便定义交叉熵损失函数。</li>
<li>网络的第二部分给出框的精确位置，一般称为框回归。P-Net输入的$12\times{12}$的图像块可能并不是完美的人脸框的位置，如有的时候人脸并不正好为方形，有可能$12\times{12}$的图像偏左或偏右，因此需要输出当前框位置相对完美的人脸框位置的偏移。这个偏移大小为$1\times{1}\times{4}$，即表示框左上角的横坐标的相对偏移，框左上角的纵坐标的相对偏移、框的宽度的误差、框的高度的误差。</li>
<li>网络的第三部分给出人脸的5个关键点的位置。5个关键点分别对应着左眼的位置、右眼的位置、鼻子的位置、左嘴巴的位置、右嘴巴的位置。每个关键点需要两维来表示，因此输出是向量大小为$1\times{1}\times{10}$。</li></ul>
<h4>2、R-Net</h4>
<p>由于P-Net的检测时比较粗略的，所以接下来使用R-Net进一步优化。R-Net和P-Net类似，不过这一步的输入是前面P-Net生成的边界框，不管实际边界框的大小，在输入R-Net之前，都需要缩放到$24\times{24}\times{3}$。网络的输出和P-Net是一样的。这一步的目的主要是为了去除大量的非人脸框。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180925215910605-1795751806.png" /></p>
<h4>3、O-Net</h4>
<p>进一步将R-Net的所得到的区域缩放到$48\times{48}\times{3}$，输入到最后的O-Net，O-Net的结构与P-Net类似，只不过在测试输出的时候多了关键点位置的输出。输入大小为$48\times{48}\times{3}$的图像，输出包含$P$个边界框的坐标信息，score以及关键点位置。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180925220805555-297541771.png" /></p>
<p>从P-Net到R-Net，再到最后的O-Net，网络输入的图像越来越大，卷积层的通道数越来越多，网络的深度也越来越深，因此识别人脸的准确率应该也是越来越高的。同时P-Net网络的运行速度越快，R-Net次之、O-Net运行速度最慢。之所以使用三个网络，是因为一开始如果直接对图像使用O-Net网络，速度会非常慢。实际上P-Net先做了一层过滤，将过滤后的结果再交给R-Net进行过滤，最后将过滤后的结果交给效果最好但是速度最慢的O-Net进行识别。这样在每一步都提前减少了需要判别的数量，有效地降低了计算的时间。</p>
<h3>二 MTCNN损失函数</h3>
<p>由于MTCNN包含三个子网络，因此其损失函数也由三部分组成。针对人脸识别问题，直接使用交叉熵代价函数，对于框回归和关键点定位，使用$L2$损失。最后把这三部分的损失各自乘以自身的权重累加起来，形成最后的总损失。在训练P-Net和R-Net的时候，我们主要关注目标框的准确度，而较少关注关键点判定的损失，因此关键点损失所占的权重较小。对于O-Net，比较关注的是关键点的位置，因此关键点损失所占的权重就会比较大。</p>
<h4>1、人脸识别损失函数</h4>
<p>在针对人脸识别的问题，对于输入样本$x_i$,我们使用交叉熵代价函数：</p>
<p>$$L_i^{det}=-(y_i^{det}log(p_i) + (1-y_i^{det})(1-log(p_i)))$$</p>
<p>其中$y_i^{det}$表示样本的真实标签，$p_i$表示网络输出为人脸的概率。</p>
<h4>2、框回归</h4>
<p>对于目标框的回归，我们采用的是欧氏距离：</p>
<p>$$L_i^{box}=\|\hat{y}_i^{box} - y_i^{box}\|$$</p>
<p>其中$\hat{y}_i^{box}$表示网络输出之后校正得到的边界框的坐标，$y_i^{box}$是目标的真实边界框。</p>
<h4>3、关键点损失函数</h4>
<p>对于关键点，我们也采用的是欧氏距离：</p>
<p>$$L_i^{landmark}=\|\hat{y}_i^{landmark} - y_i^{landmark}\|$$</p>
<p>其中$\hat{y}_i^{landmark}$表示网络输出之后得到的关键点的坐标，$y_i^{landmark}$是关键点的真实坐标。</p>
<h4>4、总损失</h4>
<p>把上面三个损失函数按照不同的权重联合起来：</p>
<p>$$min\sum\limits_{i=1}^{N}\sum\limits_{j\in\{det,box,landmark\}}\alpha_j\beta_i^jL_i^j$$</p>
<p>其中$N$是训练样本的总数，$\alpha_j$表示各个损失所占的权重，在P-Net和R-net中，设置$\alpha_{det}=1,\alpha_{box}=0.5,\alpha_{landmark}=0.5$，在O-Net中，设置$\alpha_{det}=1,\alpha_{box}=0.5,\alpha_{landmark}=1$,$\beta_i^j\in\{0,1\}$表示样本类型指示符。</p>
<h4>5、Online Hard sample mining</h4>
<h5>In particular, in each mini-batch, we sort the losses computed in the forward propagation from all samples and select the top 70% of them as hard samples. Then we only compute the gradients from these hard samples in the backward propagation.That means we ignore the easy samples that are less helpful to strengthen the detector during training. Experiments show that this strategy yields better performance without manual sampleselection.</h5>
<p>这段话也就是说，我们在训练的时候取前向传播损失值(从大到小)前70%的样本，来进行反向传播更新参数。</p>
<h4>6、训练数据</h4>
<p>该算法训练数据来源于wider和celeba两个公开的数据库，wider提供人脸检测数据，在大图上标注了人脸框groundtruth的坐标信息，celeba提供了5个landmark点的数据。根据参与任务的不同，将训练数据分为四类:</p>
<ul><li>负样本：滑动窗口和Ground True的IOU小于0.3；</li>
<li>正样本：滑动窗口和Ground True的IOU大于0.65；</li>
<li>中间样本：滑动窗口和Ground True的IOU大于0.4小于0.65；</li>
<li>关键点：包含5个关键点做标的；</li></ul>
<p>上面滑动窗口指的是：通过滑动窗口或者随机采样的方法获取尺寸为$12\times{12}$的框：</p>
<p>wider数据集，数据可以从<a href="http://mmlab.ie.cuhk.edu.hk/projects/WIDERFace/" rel="external nofollow noreferrer">http://mmlab.ie.cuhk.edu.hk/projects/WIDERFace/</a>地址下载。该数据集有32,203张图片，共有93,703张脸被标记，如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180926102305651-686169488.png" /></p>
<p>celeba人脸关键点检测的训练数据，数据可从<a href="http://mmlab.ie.cuhk.edu.hk/archive/CNN_FacePoint.htm" rel="external nofollow noreferrer">http://mmlab.ie.cuhk.edu.hk/archive/CNN_FacePoint.htm</a>地址下载。该数据集包含5,590张 LFW数据集的图片和7,876张从网站下载的图片。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180926102446944-62478251.png" /></p>
<h3>三 人脸识别</h3>
<p>在上面我们已经介绍了人脸检测，人脸检测是人脸相关任务的前提，人脸相关的任务主要有以下几种：</p>
<ul><li>人脸跟踪(视频中跟踪人脸位置变化)；</li>
<li>人脸验证(输入两张人脸，判断是否属于同一人)；</li>
<li>人脸识别(输入一张人脸，判断其属于人脸数据库记录中哪一个人)；</li>
<li>人脸聚类(输入一批人脸，将属于同一人的自动归为一类)；</li></ul>
<p>下面我们来详细介绍人脸识别技术：当我们通过MTCNN网络检测到人脸区域图像时，我们使用深度卷积网络，将输入的人脸图像转换为一个向量的表示，也就是所谓的特征。</p>
<p>那我们如何对人脸提取特征？我们先来回忆一下VGG16网络，输入的是图像，经过一系列卷积计算、全连接网络之后，输出的是类别概率。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180930094625446-944764662.png" /></p>
<p>在通常的图像应用中，可以去掉全连接层，使用卷积层的最后一层当做图像的&ldquo;特征&rdquo;，如上图中的conv5_3。但如果对人脸识别问题同样采用这样的方法，即，使用卷积层最后一层做为人脸的&ldquo;向量表示&rdquo;，效果其实是不好的。如何改进？我们之后再谈，这里先谈谈我们希望这种人脸的&ldquo;向量表示&rdquo;应该具有哪些性质。</p>
<p>在理想的状况下，我们希望&ldquo;向量表示&rdquo;之间的距离就可以直接反映人脸的相似度：</p>
<ul><li><p>对于同一个人的人脸图像，对应的向量的欧几里得距离应该比较小；</p></li>
<li><p>对于不同人的人脸图像，对应的向量之间的欧几里得距离应该比较大；</p></li></ul>
<p>例如：设人脸图像为$x_1,x_2$，对应的特征为$f(x_1),f(x_2)$，当$x_1,x_2$对应是同一个人的人脸时，$f(x_1),f(x_2)$的距离$\|f(x_1)-f(x_2)\|_2$应该很小，而当$x_1,x_2$对应的不是同一个人的人脸时，$f(x_1),f(x_2)$的距离$\|f(x_1)-f(x_2)\|_2$应该很大。</p>
<p>在原始的VGG16模型中，我们使用的是softmax损失，softmax是类别间的损失，对于人脸来说，每一类就是一个人。尽管使用softmax损失可以区别每个人，但其本质上没有对每一类的向量表示之间的距离做出要求。</p>
<p>举个例子，使用CNN对MNIST进行分类，我们设计一个特殊的卷积网络，让最后一层的向量变为2维，此时可以画出每一类对应的2维向量表示的图（图中一种颜色对应一种类别）：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180930101737837-364549832.png" /></p>
<p>上图是我们直接使用softmax训练得到的结果，它就不符合我们希望特征具有的特点：</p>
<ul><li><p>我们希望同一类对应的向量表示尽可能接近。但这里同一类（如紫色），可能具有很大的类间距离；</p></li>
<li><p>我们希望不同类对应的向量应该尽可能远。但在图中靠中心的位置，各个类别的距离都很近；</p></li></ul>
<p>对于人脸图像同样会出现类似的情况，对此，有很改进方法。这里介绍其中两种：三元组损失函数，中心损失函数。</p>
<h4>1、三元组损失</h4>
<p>三元组损失函数的原理：既然目标是特征之间的距离应该具备某些性质，那么我们就围绕这个距离来设计损失。具体的，我们每次都在训练数据中抽出三张人脸图像，第一张图像标记为$x_i^a$，第二章图像标记为$x_i^p$，第三张图像标记为$x_i^n$。在这样一个"三元组"中，$x_i^a$和$x_i^p$对应的是同一个人的图像，而$x_i^n$是另外一个人的人脸图像。因此距离$\|f(x_i^a)-f(x_i^p)\|_2$应该很小，而距离$\|f(x_i^a)-f(x_i^n)\|_2$应该很大。严格来说，三元组损失要求满足以下不等式：</p>
<p>$$\|f(x_i^a)-f(x_i^p)\|_2^2+\alpha &lt; \|f(x_i^a)-f(x_i^n)\|_2^2$$</p>
<p>即相同人脸间的距离平方至少要比不同人脸间的距离平方小$\alpha$(取平方主要是为了方便求导)，据此，设计损失函数为：</p>
<p>$$L_i = [\|f(x_i^a)-f(x_i^p)\|_2^2+\alpha - \|f(x_i^a)-f(x_i^n)\|_2^2]_+$$</p>
<p>这样的话，当三元组的距离满足$\|f(x_i^a)-f(x_i^p)\|_2^2+\alpha &lt; \|f(x_i^a)-f(x_i^n)\|_2^2$时，损失$L_i=0$。当距离不满足上述不等式时，就会有值为$\|f(x_i^a)-f(x_i^p)\|_2^2+\alpha - \|f(x_i^a)-f(x_i^n)\|_2^2$的损失，此外，在训练时会固定$\|f(x)\|_2=1$，以确保特征不会无限的"远离"。</p>
<p>三元组损失直接对距离进行优化，因此可以解决人脸的特征表示问题。但是在训练过程中，三元组的选择非常地有技巧性。如果每次都是随机选择三元组，虽然模型可以正确的收敛，但是并不能达到最好的性能。如果加入"难例挖掘"，即每次都选择最难分辨率的三元组进行训练，模型又往往不能正确的收敛。对此，又提出每次都选择那些"半难"的数据进行训练，让模型在可以收敛的同时也保持良好的性能。此外，使用三元组损失训练人脸模型通常还需要非常大的人脸数据集，才能取得较好的效果。</p>
<h4>2、中心损失</h4>
<p>与三元组损失不同，中心损失不直接对距离进行优化，它保留了原有的分类模型，但又为每个类(在人脸模型中，一个类就对应一个人)指定了一个类别中心。同一类的图像对应的特征都应该尽量靠近自己的类别中心，不同类的类别中心尽量远离。与三元组损失函数，使用中心损失训练人脸模型不需要使用特别的采样方法，而且利用较少的图像就可以达到与单元组损失相似的效果。下面我们一起来学习中心损失的定义：</p>
<p>设输入的人脸图像为$x_i$，该人脸对应的类别是$y_i$，对每个类别都规定一个类别中心，记作$c_{yi}$。希望每个人脸图像对应的特征$f(x_i)$都尽可能接近中心$c_{yi}$。因此定义损失函数为：</p>
<p>$$L_i=\frac{1}{2}\|f(x_i)-c_{yi}\|_2^2$$</p>
<p>多张图像的中心损失就是将它们的值累加：</p>
<p>$$L_{center}=\sum\limits_{i}L_i$$</p>
<p>这是一个非常简单的定义。不过还有一个问题没有解决，那就是如何确定每个类别的中心$c_{yi}$呢？从理论上来说，类别$y_i$的最佳中心应该是它对应所有图片的特征的平均值。但如果采用这样的定义，那么在每一次梯度下降时，都要对所有图片计算一次$c_{yi}$，计算复杂度太高了。针对这种情况，不妨近似处理下，在初始阶段，先随机确定$c_{yi}$，接着在每个batch内，使用$L_i=\|f(x_i)-c_{yi}\|_2^2$对当前batch内的$c_{yi}$也计算梯度，并使得该梯度更新$c_{yi}$，此外，不能只使用中心损失来训练分类模型，还需要加入softmax损失，也就是说，损失最后由两部分组成，即$L=L_{softmax}+\lambda{L_{center}}$,其中$\lambda$是一个超参数。</p>
<p>最后来总结使用中心损失来训练人脸模型的过程。首先随机初始化各个中心$c_{yi}$，接着不断地取出batch进行训练，在每个batch中，使用总的损失$L$，除了使用神经网络模型的参数对模型进行更新外，也对$c_{yi}$进行计算梯度，并更新中心的位置。</p>
<p>中心损失可以让训练处的特征具有"内聚性"。还是以MNIST的例子来说，在未加入中心损失时，训练的结果不具有内聚性。在加入中心损失后，得到的特征如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180930141427384-1438017226.png" /></p>
<p>当中心损失的权重$\lambda$越大时，生成的特征就会具有越明显的"内聚性"。</p>
<h3>四 人脸识别的实现</h3>
<p>下面我们会介绍一个经典的人脸识别系统-谷歌人脸识别系统facenet，该网络主要包含两部分：</p>
<ul><li>MTCNN部分：用于人脸检测和人脸对齐，输出$160\times{160}$大小的图像；</li>
<li>CNN部分：可以直接将人脸图像(默认输入是$160\times{160}$大小)映射到欧几里得空间，空间距离的长度代表了人脸图像的相似性。只要该映射空间生成、人脸识别，验证和聚类等任务就可以轻松完成；</li></ul>
<p>先去GitHub下载facenet源码：<a href="https://github.com/davidsandberg/facenet" rel="external nofollow noreferrer">https://github.com/davidsandberg/facenet</a>，解压后如下图所示；</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180930142742977-1707345585.png" /></p>
<p>打开requirements.txt，我们可以看到我们需要安装以下依赖：</p>
<div>
<pre class="prettyprint linenums">tensorflow==1.7<br />
scipy<br />
scikit-learn<br />
opencv-python<br />
h5py<br />
matplotlib<br />
Pillow<br />
requests<br />
psutil</pre>
</div>
<p>后面在运行程序时，如果出现安装包兼容问题，建议这里使用pip安装，不要使用conda。</p>
<h4>1、配置Facenet环境</h4>
<p>将facebet文件夹加到python引入库的默认搜索路径中，将facenet文件整个复制到anaconda3安装文件目录下lib\site-packages下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180930143856182-855997440.png" /></p>
<p>然后把剪切src目录下的文件，然后删除facenet下的所有文件，粘贴src目录下的文件到facenet下，这样做的目的是为了导入src目录下的包(这样import align.detect_face不会报错)。</p>
<p>在Anaconda Prompt中运行python，输入import facenet，不报错即可：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180930143946065-1828406441.png" /></p>
<h4>2、下载LFW数据集</h4>
<p>接下来将会讲解如何使用已经训练好的模型在LFW（Labeled Faces in the Wild）数据库上测试，不过我还需要先来介绍一下LFW数据集。</p>
<p>LFW数据集是由美国马赛诸塞大学阿姆斯特分校计算机实验室整理的人脸检测数据集，是评估人脸识别算法效果的公开测试数据集。LFW数据集共有13233张jpeg格式图片，属于5749个不同的人，其中有1680人对应不止一张图片，每张图片尺寸都是$250\times{250}$，并且被标示出对应的人的名字。LFW数据集中每张图片命名方式为"lfw/name/name_xxx.jpg"，这里"xxx"是前面补零的四位图片编号。例如，前美国总统乔治布什的第十张图片为"lfw/George_W_Bush/George_W_Bush_0010.jpg"。</p>
<p>数据集的下载地址为：<a href="http://vis-www.cs.umass.edu/lfw/lfw.tgz" rel="external nofollow noreferrer">http://vis-www.cs.umass.edu/lfw/lfw.tgz</a>，下载完成后，解压数据集，打开打开其中一个文件夹，如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180930200205468-128050022.png" /></p>
<p>在lfw下新建一个文件夹raw，把lfw中所有的文件(除了raw)移到raw文件夹中。可以看到我的数据集lfw是放在datasets文件夹下，其中datasets文件夹和facenet是在同一路径下。</p>
<h4>3、LFW数据集预处理(LFW数据库上的人脸检测和对齐)</h4>
<p>我们需要将检测所使用的数据集校准为和训练模型所使用的数据集大小一致($160\times{160}$)，转换后的数据集存储在lfw_mtcnnpy_160文件夹内，</p>
<p>处理的第一步是使用MTCNN网络进行人脸检测和对齐，并缩放到$160\times{160}$。</p>
<p>MTCNN的实现主要在文件夹facenet/src/align中，文件夹的内容如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180930193813200-813548759.png" /></p>
<ul><li>detect_face.py：定义了MTCNN的模型结构，由P-Net、R-Net、O-Net组成，这三个网络已经提供了预训练的模型，模型数据分别对应文件det1.npy、det2.npy、det3.npy。</li>
<li>align_dataset_matcnn.py：是使用MTCNN的模型进行人脸检测和对齐的入口代码。</li></ul>
<p>使用脚本align_dataset_mtcnn.py对LFW数据库进行人脸检测和对齐的方法通过运行命令，我们打开Anaconda Prompt，来到facenet所在的路径下，运行如下命令：</p>
<div>
<pre class="prettyprint linenums">python  facenet/src/align/align_dataset_mtcnn.py   datasets/lfw/raw  datasets/lfw/lfw_mtcnnpy_160 --image_size 160 --margin 32 --random_order</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180930223629821-1575664261.png" /></p>
<p>该命令会创建一个datasets/lfw/lfw_mtcnnpy_160的文件夹，并将所有对齐好的人脸图像存放到这个文件夹中，数据的结构和原先的datasets/lfw/raw一样。参数--image_size 160 --margin 32的含义是在MTCNN检测得到的人脸框的基础上缩小32像素(训练时使用的数据偏大)，并缩放到$160\times{160}$大小，因此最后得到的对齐后的图像都是$160\times{160}$像素的，这样的话，就成功地从原始图像中检测并对齐了人脸。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201809/1328274-20180930223832235-212453626.png" /></p>
<p>下面我们来简略的分析一下align_dataset_mtcnn.py源文件，先上源代码如下，然后我们来解读一下main()函数</p>
<div>
<div>
<pre class="prettyprint linenums">"""Performs face alignment and stores face thumbnails in the output directory."""<br />
# MIT License<br />
#<br />
# Copyright (c) 2016 David Sandberg<br />
#<br />
# Permission is hereby granted, free of charge, to any person obtaining a copy<br />
# of this software and associated documentation files (the "Software"), to deal<br />
# in the Software without restriction, including without limitation the rights<br />
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell<br />
# copies of the Software, and to permit persons to whom the Software is<br />
# furnished to do so, subject to the following conditions:<br />
#<br />
# The above copyright notice and this permission notice shall be included in all<br />
# copies or substantial portions of the Software.<br />
#<br />
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR<br />
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,<br />
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE<br />
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER<br />
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,<br />
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE<br />
# SOFTWARE.

from __future__ import absolute_import<br />
from __future__ import division<br />
from __future__ import print_function

from scipy import misc<br />
import sys<br />
import os<br />
import argparse<br />
import tensorflow as tf<br />
import numpy as np<br />
import facenet<br />
import align.detect_face<br />
import random<br />
from time import sleep

'''<br />
使用MTCNN网络进行人脸检测和对齐<br />
'''

def main(args):<br />
    '''<br />
    args:<br />
        args：参数，关键字参数<br />
    '''

    sleep(random.random())<br />
    #设置对齐后的人脸图像存放的路径<br />
    output_dir = os.path.expanduser(args.output_dir)<br />
    if not os.path.exists(output_dir):<br />
        os.makedirs(output_dir)<br />
    # Store some git revision info in a text file in the log directory  保存一些配置参数等信息<br />
    src_path,_ = os.path.split(os.path.realpath(__file__))<br />
    facenet.store_revision_info(src_path, output_dir, ' '.join(sys.argv))

    '''1、获取LFW数据集 获取每个类别名称以及该类别下所有图片的绝对路径'''<br />
    dataset = facenet.get_dataset(args.input_dir)

    print('Creating networks and loading parameters')

    '''2、建立MTCNN网络，并预训练(即使用训练好的网络初始化参数)'''<br />
    with tf.Graph().as_default():<br />
        gpu_options = tf.GPUOptions(per_process_gpu_memory_fraction=args.gpu_memory_fraction)<br />
        sess = tf.Session(config=tf.ConfigProto(gpu_options=gpu_options, log_device_placement=False))<br />
        with sess.as_default():<br />
            pnet, rnet, onet = align.detect_face.create_mtcnn(sess, None)

    minsize = 20                   # minimum size of face<br />
    threshold = [ 0.6, 0.7, 0.7 ]  # three steps's threshold<br />
    factor = 0.709                 # scale factor

    # Add a random key to the filename to allow alignment using multiple processes<br />
    random_key = np.random.randint(0, high=99999)<br />
    bounding_boxes_filename = os.path.join(output_dir, 'bounding_boxes_%05d.txt' % random_key)

    '''3、每个图片中人脸所在的边界框写入记录文件中'''<br />
    with open(bounding_boxes_filename, "w") as text_file:<br />
        nrof_images_total = 0<br />
        nrof_successfully_aligned = 0<br />
        if args.random_order:<br />
            random.shuffle(dataset)<br />
        #获取每一个人，以及对应的所有图片的绝对路径<br />
        for cls in dataset:<br />
            #每一个人对应的输出文件夹<br />
            output_class_dir = os.path.join(output_dir, cls.name)<br />
            if not os.path.exists(output_class_dir):<br />
                os.makedirs(output_class_dir)<br />
                if args.random_order:<br />
                    random.shuffle(cls.image_paths)<br />
            #遍历每一张图片<br />
            for image_path in cls.image_paths:<br />
                nrof_images_total += 1<br />
                filename = os.path.splitext(os.path.split(image_path)[1])[0]<br />
                output_filename = os.path.join(output_class_dir, filename+'.png')<br />
                print(image_path)<br />
                if not os.path.exists(output_filename):<br />
                    try:<br />
                        img = misc.imread(image_path)<br />
                    except (IOError, ValueError, IndexError) as e:<br />
                        errorMessage = '{}: {}'.format(image_path, e)<br />
                        print(errorMessage)<br />
                    else:<br />
                        if img.ndim&lt;2:<br />
                            print('Unable to align "%s"' % image_path)<br />
                            text_file.write('%s\n' % (output_filename))<br />
                            continue<br />
                        if img.ndim == 2:<br />
                            img = facenet.to_rgb(img)<br />
                        img = img[:,:,0:3]

                        #人脸检测 bounding_boxes：表示边界框 形状为[n,5] 5对应x1,y1,x2,y2,score<br />
                        #_：人脸关键点坐标 形状为 [n,10]<br />
                        bounding_boxes, _ = align.detect_face.detect_face(img, minsize, pnet, rnet, onet, threshold, factor)<br />
                        #边界框个数<br />
                        nrof_faces = bounding_boxes.shape[0]<br />
                        if nrof_faces&gt;0:<br />
                            #[n,4] 人脸框<br />
                            det = bounding_boxes[:,0:4]<br />
                            #保存所有人脸框<br />
                            det_arr = []<br />
                            img_size = np.asarray(img.shape)[0:2]<br />
                            if nrof_faces&gt;1:<br />
                                #一张图片中检测多个人脸<br />
                                if args.detect_multiple_faces:<br />
                                    for i in range(nrof_faces):<br />
                                        det_arr.append(np.squeeze(det[i]))<br />
                                else:<br />
                                    bounding_box_size = (det[:,2]-det[:,0])*(det[:,3]-det[:,1])<br />
                                    img_center = img_size / 2<br />
                                    offsets = np.vstack([ (det[:,0]+det[:,2])/2-img_center[1], (det[:,1]+det[:,3])/2-img_center[0] ])<br />
                                    offset_dist_squared = np.sum(np.power(offsets,2.0),0)<br />
                                    index = np.argmax(bounding_box_size-offset_dist_squared*2.0) # some extra weight on the centering<br />
                                    det_arr.append(det[index,:])<br />
                            else:<br />
                                #只有一个人脸框<br />
                                det_arr.append(np.squeeze(det))

                            #遍历每一个人脸框<br />
                            for i, det in enumerate(det_arr):<br />
                                #[4,]  边界框扩大margin区域，并进行裁切<br />
                                det = np.squeeze(det)<br />
                                bb = np.zeros(4, dtype=np.int32)<br />
                                bb[0] = np.maximum(det[0]-args.margin/2, 0)<br />
                                bb[1] = np.maximum(det[1]-args.margin/2, 0)<br />
                                bb[2] = np.minimum(det[2]+args.margin/2, img_size[1])<br />
                                bb[3] = np.minimum(det[3]+args.margin/2, img_size[0])<br />
                                cropped = img[bb[1]:bb[3],bb[0]:bb[2],:]<br />
                                #缩放到指定大小，并保存图片，以及边界框位置信息<br />
                                scaled = misc.imresize(cropped, (args.image_size, args.image_size), interp='bilinear')<br />
                                nrof_successfully_aligned += 1<br />
                                filename_base, file_extension = os.path.splitext(output_filename)<br />
                                if args.detect_multiple_faces:<br />
                                    output_filename_n = "{}_{}{}".format(filename_base, i, file_extension)<br />
                                else:<br />
                                    output_filename_n = "{}{}".format(filename_base, file_extension)<br />
                                misc.imsave(output_filename_n, scaled)<br />
                                text_file.write('%s %d %d %d %d\n' % (output_filename_n, bb[0], bb[1], bb[2], bb[3]))<br />
                        else:<br />
                            print('Unable to align "%s"' % image_path)<br />
                            text_file.write('%s\n' % (output_filename))

    print('Total number of images: %d' % nrof_images_total)<br />
    print('Number of successfully aligned images: %d' % nrof_successfully_aligned)

def parse_arguments(argv):<br />
    '''<br />
    解析命令行参数<br />
    '''<br />
    parser = argparse.ArgumentParser()

    #定义参数  input_dir、output_dir为外部参数名<br />
    parser.add_argument('input_dir', type=str, help='Directory with unaligned images.')<br />
    parser.add_argument('output_dir', type=str, help='Directory with aligned face thumbnails.')<br />
    parser.add_argument('--image_size', type=int,<br />
        help='Image size (height, width) in pixels.', default=160)<br />
    parser.add_argument('--margin', type=int,<br />
        help='Margin for the crop around the bounding box (height, width) in pixels.', default=32)<br />
    parser.add_argument('--random_order',<br />
        help='Shuffles the order of images to enable alignment using multiple processes.', action='store_true')<br />
    parser.add_argument('--gpu_memory_fraction', type=float,<br />
        help='Upper bound on the amount of GPU memory that will be used by the process.', default=1.0)<br />
    parser.add_argument('--detect_multiple_faces', type=bool,<br />
                        help='Detect and align multiple faces per image.', default=False)<br />
    #解析<br />
    return parser.parse_args(argv)

if __name__ == '__main__':<br />
    main(parse_arguments(sys.argv[1:]))</pre>
</div>
</div>
<ul><li>首先加载LFW数据集；</li>
<li>建立MTCNN网络，并预训练(即使用训练好的网络初始化参数)，Google Facenet的作者在建立网络时，自己重写了CNN网络所需的各个组件，包括conv层,MaxPool层，Softmax层等等，由于作者写的比较复杂。有兴趣的同学看看<a href="https://blog.csdn.net/FortiLZ/article/details/81396566" rel="external nofollow noreferrer">MTCNN 的 TensorFlow 实现</a>这篇博客，博主使用Keras重新实现了MTCNN网络，也比较好懂代码链接：<a href="https://github.com/FortiLeiZhang/model_zoo/tree/master/TensorFlow/mtcnn" rel="external nofollow noreferrer">https://github.com/FortiLeiZhang/model_zoo/tree/master/TensorFlow/mtcnn</a>；</li>
<li>调用align.detect_face.detect_face()函数进行人脸检测，返回校准后的人脸边界框的位置、score、以及关键点坐标；</li>
<li>对人脸框进行处理，从原图中裁切(先进行了边缘扩展32个像素)、以及缩放(缩放到$160\times{160}$)等，并保存相关信息到文件；</li></ul>
<p>关于人脸检测的具体细节可以查看detect_face()函数，代码也比较长，这里我放上代码，具体细节部分可以参考<a href="https://blog.csdn.net/FortiLZ/article/details/81396566" rel="external nofollow noreferrer">MTCNN 的 TensorFlow 实现</a>这篇博客。</p>
<div>
<div>
<pre class="prettyprint linenums">def detect_face(img, minsize, pnet, rnet, onet, threshold, factor):<br />
    """Detects faces in an image, and returns bounding boxes and points for them.<br />
    img: input image<br />
    minsize: minimum faces' size<br />
    pnet, rnet, onet: caffemodel<br />
    threshold: threshold=[th1, th2, th3], th1-3 are three steps's threshold<br />
    factor: the factor used to create a scaling pyramid of face sizes to detect in the image.<br />
    """<br />
    factor_count=0<br />
    total_boxes=np.empty((0,9))<br />
    points=np.empty(0)<br />
    h=img.shape[0]<br />
    w=img.shape[1]<br />
    #最小值 假设是250x250<br />
    minl=np.amin([h, w])<br />
    #假设最小人脸 minsize=20，由于我们P-Net人脸检测窗口大小为12x12，<br />
    #因此必须缩放才能使得检测窗口检测到完整的人脸 m=0.6<br />
    m=12.0/minsize<br />
    #<br />
    minl=minl*m<br />
    # create scale pyramid   不同尺度金字塔，保存每个尺度缩放尺度系数0.6  0.6*0.7 ...<br />
    scales=[]<br />
    while minl&gt;=12:<br />
        scales += [m*np.power(factor, factor_count)]<br />
        minl = minl*factor<br />
        factor_count += 1

    # first stage  P-Net<br />
    for scale in scales:<br />
        #缩放图像<br />
        hs=int(np.ceil(h*scale))<br />
        ws=int(np.ceil(w*scale))<br />
        im_data = imresample(img, (hs, ws))<br />
        #归一化[-1,1]之间<br />
        im_data = (im_data-127.5)*0.0078125<br />
        img_x = np.expand_dims(im_data, 0)<br />
        img_y = np.transpose(img_x, (0,2,1,3))<br />
        out = pnet(img_y)<br />
        #输入图像是[1,150,150,3] 则输出为[1,70,70,4] 边界框，每一个特征点都对应一个12x12大小检测窗口<br />
        out0 = np.transpose(out[0], (0,2,1,3))<br />
        #输入图像是[1,150,150,3] 则输出为[1,70,70,2] 人脸概率<br />
        out1 = np.transpose(out[1], (0,2,1,3))

        #输出为[n,9] 前4位为人脸框在原图中的位置，第5位为判定为人脸的概率，后4位为框回归的值<br />
        boxes, _ = generateBoundingBox(out1[0,:,:,1].copy(), out0[0,:,:,:].copy(), scale, threshold[0])

        # inter-scale nms  非极大值抑制，然后保存剩下的bb<br />
        pick = nms(boxes.copy(), 0.5, 'Union')<br />
        if boxes.size&gt;0 and pick.size&gt;0:<br />
            boxes = boxes[pick,:]<br />
            total_boxes = np.append(total_boxes, boxes, axis=0)

    #图片按照所有scale走完一遍，会得到在原图上基于不同scale的所有的bb，然后对这些bb再进行一次NMS<br />
    #并且这次NMS的threshold要提高<br />
    numbox = total_boxes.shape[0]<br />
    if numbox&gt;0:<br />
        pick = nms(total_boxes.copy(), 0.7, 'Union')<br />
        total_boxes = total_boxes[pick,:]<br />
        #使用框回归校准bb  框回归：框左上角的横坐标的相对偏移，框左上角的纵坐标的相对偏移、框的宽度的误差、框的高度的误差。<br />
        regw = total_boxes[:,2]-total_boxes[:,0]<br />
        regh = total_boxes[:,3]-total_boxes[:,1]<br />
        qq1 = total_boxes[:,0]+total_boxes[:,5]*regw<br />
        qq2 = total_boxes[:,1]+total_boxes[:,6]*regh<br />
        qq3 = total_boxes[:,2]+total_boxes[:,7]*regw<br />
        qq4 = total_boxes[:,3]+total_boxes[:,8]*regh<br />
        #[n,8]<br />
        total_boxes = np.transpose(np.vstack([qq1, qq2, qq3, qq4, total_boxes[:,4]]))<br />
        #把每一个bb转换为正方形<br />
        total_boxes = rerec(total_boxes.copy())<br />
        total_boxes[:,0:4] = np.fix(total_boxes[:,0:4]).astype(np.int32)<br />
        #把超过原图边界的坐标裁切一下，这时候得到真正原图上bb的坐标<br />
        dy, edy, dx, edx, y, ey, x, ex, tmpw, tmph = pad(total_boxes.copy(), w, h)

    numbox = total_boxes.shape[0]<br />
    if numbox&gt;0:<br />
        # second stage R-Net 对于P-Net输出的bb，缩放到24x24大小<br />
        tempimg = np.zeros((24,24,3,numbox))<br />
        for k in range(0,numbox):<br />
            tmp = np.zeros((int(tmph[k]),int(tmpw[k]),3))<br />
            tmp[dy[k]-1:edy[k],dx[k]-1:edx[k],:] = img[y[k]-1:ey[k],x[k]-1:ex[k],:]<br />
            if tmp.shape[0]&gt;0 and tmp.shape[1]&gt;0 or tmp.shape[0]==0 and tmp.shape[1]==0:<br />
                tempimg[:,:,:,k] = imresample(tmp, (24, 24))<br />
            else:<br />
                return np.empty()<br />
        #标准化 [-1,1]<br />
        tempimg = (tempimg-127.5)*0.0078125<br />
        #转置[n,24,24,3]<br />
        tempimg1 = np.transpose(tempimg, (3,1,0,2))<br />
        out = rnet(tempimg1)<br />
        out0 = np.transpose(out[0])<br />
        out1 = np.transpose(out[1])<br />
        score = out1[1,:]<br />
        ipass = np.where(score&gt;threshold[1])<br />
        total_boxes = np.hstack([total_boxes[ipass[0],0:4].copy(), np.expand_dims(score[ipass].copy(),1)])<br />
        mv = out0[:,ipass[0]]<br />
        if total_boxes.shape[0]&gt;0:<br />
            pick = nms(total_boxes, 0.7, 'Union')<br />
            total_boxes = total_boxes[pick,:]<br />
            total_boxes = bbreg(total_boxes.copy(), np.transpose(mv[:,pick]))<br />
            total_boxes = rerec(total_boxes.copy())

    numbox = total_boxes.shape[0]<br />
    if numbox&gt;0:<br />
        # third stage O-Net<br />
        total_boxes = np.fix(total_boxes).astype(np.int32)<br />
        dy, edy, dx, edx, y, ey, x, ex, tmpw, tmph = pad(total_boxes.copy(), w, h)<br />
        tempimg = np.zeros((48,48,3,numbox))<br />
        for k in range(0,numbox):<br />
            tmp = np.zeros((int(tmph[k]),int(tmpw[k]),3))<br />
            tmp[dy[k]-1:edy[k],dx[k]-1:edx[k],:] = img[y[k]-1:ey[k],x[k]-1:ex[k],:]<br />
            if tmp.shape[0]&gt;0 and tmp.shape[1]&gt;0 or tmp.shape[0]==0 and tmp.shape[1]==0:<br />
                tempimg[:,:,:,k] = imresample(tmp, (48, 48))<br />
            else:<br />
                return np.empty()<br />
        tempimg = (tempimg-127.5)*0.0078125<br />
        tempimg1 = np.transpose(tempimg, (3,1,0,2))<br />
        out = onet(tempimg1)<br />
        #关键点<br />
        out0 = np.transpose(out[0])<br />
        #框回归<br />
        out1 = np.transpose(out[1])<br />
        #人脸概率<br />
        out2 = np.transpose(out[2])<br />
        score = out2[1,:]<br />
        points = out1<br />
        ipass = np.where(score&gt;threshold[2])<br />
        points = points[:,ipass[0]]<br />
        #[n,5]<br />
        total_boxes = np.hstack([total_boxes[ipass[0],0:4].copy(), np.expand_dims(score[ipass].copy(),1)])<br />
        mv = out0[:,ipass[0]]

        w = total_boxes[:,2]-total_boxes[:,0]+1<br />
        h = total_boxes[:,3]-total_boxes[:,1]+1<br />
        #人脸关键点<br />
        points[0:5,:] = np.tile(w,(5, 1))*points[0:5,:] + np.tile(total_boxes[:,0],(5, 1))-1<br />
        points[5:10,:] = np.tile(h,(5, 1))*points[5:10,:] + np.tile(total_boxes[:,1],(5, 1))-1<br />
        if total_boxes.shape[0]&gt;0:<br />
            total_boxes = bbreg(total_boxes.copy(), np.transpose(mv))<br />
            pick = nms(total_boxes.copy(), 0.7, 'Min')<br />
            total_boxes = total_boxes[pick,:]<br />
            points = points[:,pick]

    #返回bb：[n,5] x1,y1,x2,y2,score  和关键点[n,10]<br />
    return total_boxes, points</pre>
</div>
</div>
<h4>4、使用已有模型验证LFW数据集准确率</h4>
<p>项目的原作者提供了两个预训练的模型，分别是基于CASIA-WebFace和VGGFace2人脸库训练的，下载地址：<a href="https://github.com/davidsandberg/facenet" rel="external nofollow noreferrer">https://github.com/davidsandberg/facenet</a>：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001153027847-1861163693.png" /></p>
<p>注意：这两个模型文件需要翻墙才能够下载！！！！！！</p>
<p>这里我们使用的预训练模型是基于数据集CASIA-WebFace的，并且使用的卷积网络结构是Inception ResNet v1，训练好的模型在LFW上可以达到99.05%左右的准确率。下载好模型后，将文件解压到facenet/models文件夹下(models文件夹需要自己新建)。解压后，会得到一个20180408-102900的文件夹，里面包含四个文件：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001155719764-1956639961.png" /></p>
<ul><li>model.meta：模型文件，该文件保存了metagraph信息，即计算图的结构；</li>
<li>model.ckpt.data：权重文件，该文件保存了graph中所有遍历的数据；</li>
<li>model.ckpt.index：该文件保存了如何将meta和data匹配起来的信息；</li>
<li>pb文件：将模型文件和权重文件整合合并为一个文件，主要用途是便于发布，详细内容可以参考博客<a href="https://blog.csdn.net/yjl9122/article/details/78341689" rel="external nofollow noreferrer">https://blog.csdn.net/yjl9122/article/details/78341689</a>；</li>
<li>一般情况下还会有个checkpoint文件，用于保存文件的绝对路径，告诉TF最新的检查点文件(也就是上图中后三个文件)是哪个，保存在哪里，在使用tf.train.latest_checkpoint加载的时候要用到这个信息，但是如果改变或者删除了文件中保存的路径，那么加载的时候会出错，找不到文件；</li></ul>
<p>到这里、我们的准备工作已经基本完成，测试数据集LFW，模型、程序都有了，我们接下来开始评估模型的准确率。</p>
<p>我们打开Anaconda Prompt，来到facenet路径下(注意这里是facenet路径下)，运行如下命令：</p>
<div>
<pre class="prettyprint linenums">python src/validate_on_lfw.py  ../datasets/lfw/lfw_mtcnnpy_160 models/20180408-102900</pre>
</div>
<p>运行结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001162200930-770469367.png" /></p>
<p>由此，我们验证了模型在LFW上的准确率为99.7%。</p>
<p>validate_on_lfw.py源码如下：</p>
<div>
<div>
<pre class="prettyprint linenums">"""Validate a face recognizer on the "Labeled Faces in the Wild" dataset (http://vis-www.cs.umass.edu/lfw/).<br />
Embeddings are calculated using the pairs from http://vis-www.cs.umass.edu/lfw/pairs.txt and the ROC curve<br />
is calculated and plotted. Both the model metagraph and the model parameters need to exist<br />
in the same directory, and the metagraph should have the extension '.meta'.<br />
"""<br />
# MIT License<br />
#<br />
# Copyright (c) 2016 David Sandberg<br />
#<br />
# Permission is hereby granted, free of charge, to any person obtaining a copy<br />
# of this software and associated documentation files (the "Software"), to deal<br />
# in the Software without restriction, including without limitation the rights<br />
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell<br />
# copies of the Software, and to permit persons to whom the Software is<br />
# furnished to do so, subject to the following conditions:<br />
#<br />
# The above copyright notice and this permission notice shall be included in all<br />
# copies or substantial portions of the Software.<br />
#<br />
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR<br />
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,<br />
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE<br />
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER<br />
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,<br />
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE<br />
# SOFTWARE.

from __future__ import absolute_import<br />
from __future__ import division<br />
from __future__ import print_function

import tensorflow as tf<br />
import numpy as np<br />
import argparse<br />
import facenet<br />
import lfw<br />
import os<br />
import sys<br />
from tensorflow.python.ops import data_flow_ops<br />
from sklearn import metrics<br />
from scipy.optimize import brentq<br />
from scipy import interpolate

def main(args):

    with tf.Graph().as_default():

        with tf.Session() as sess:

            # Read the file containing the pairs used for testing  list<br />
            #每个元素如下：同一个人[Abel_Pacheco    1    4]  不同人[Ben_Kingsley    1    Daryl_Hannah    1]<br />
            pairs = lfw.read_pairs(os.path.expanduser(args.lfw_pairs))

            # Get the paths for the corresponding images<br />
            # 获取测试图片的路径，actual_issame表示是否是同一个人<br />
            paths, actual_issame = lfw.get_paths(os.path.expanduser(args.lfw_dir), pairs)

            #定义占位符<br />
            image_paths_placeholder = tf.placeholder(tf.string, shape=(None,1), name='image_paths')<br />
            labels_placeholder = tf.placeholder(tf.int32, shape=(None,1), name='labels')<br />
            batch_size_placeholder = tf.placeholder(tf.int32, name='batch_size')<br />
            control_placeholder = tf.placeholder(tf.int32, shape=(None,1), name='control')<br />
            phase_train_placeholder = tf.placeholder(tf.bool, name='phase_train')

            #使用队列机制读取数据<br />
            nrof_preprocess_threads = 4<br />
            image_size = (args.image_size, args.image_size)<br />
            eval_input_queue = data_flow_ops.FIFOQueue(capacity=2000000,<br />
                                        dtypes=[tf.string, tf.int32, tf.int32],<br />
                                        shapes=[(1,), (1,), (1,)],<br />
                                        shared_name=None, name=None)<br />
            eval_enqueue_op = eval_input_queue.enqueue_many([image_paths_placeholder, labels_placeholder, control_placeholder], name='eval_enqueue_op')<br />
            image_batch, label_batch = facenet.create_input_pipeline(eval_input_queue, image_size, nrof_preprocess_threads, batch_size_placeholder)

            # Load the model<br />
            input_map = {'image_batch': image_batch, 'label_batch': label_batch, 'phase_train': phase_train_placeholder}<br />
            facenet.load_model(args.model, input_map=input_map)

            # Get output tensor<br />
            embeddings = tf.get_default_graph().get_tensor_by_name("embeddings:0")<br />
#<br />
            #创建一个协调器，管理线程<br />
            coord = tf.train.Coordinator()<br />
            tf.train.start_queue_runners(coord=coord, sess=sess)

            #开始评估<br />
            evaluate(sess, eval_enqueue_op, image_paths_placeholder, labels_placeholder, phase_train_placeholder, batch_size_placeholder, control_placeholder,<br />
                embeddings, label_batch, paths, actual_issame, args.lfw_batch_size, args.lfw_nrof_folds, args.distance_metric, args.subtract_mean,<br />
                args.use_flipped_images, args.use_fixed_image_standardization)

def evaluate(sess, enqueue_op, image_paths_placeholder, labels_placeholder, phase_train_placeholder, batch_size_placeholder, control_placeholder,<br />
        embeddings, labels, image_paths, actual_issame, batch_size, nrof_folds, distance_metric, subtract_mean, use_flipped_images, use_fixed_image_standardization):<br />
    # Run forward pass to calculate embeddings<br />
    print('Runnning forward pass on LFW images')

    # Enqueue one epoch of image paths and labels<br />
    nrof_embeddings = len(actual_issame)*2  # nrof_pairs * nrof_images_per_pair<br />
    nrof_flips = 2 if use_flipped_images else 1<br />
    nrof_images = nrof_embeddings * nrof_flips<br />
    labels_array = np.expand_dims(np.arange(0,nrof_images),1)<br />
    image_paths_array = np.expand_dims(np.repeat(np.array(image_paths),nrof_flips),1)<br />
    control_array = np.zeros_like(labels_array, np.int32)<br />
    if use_fixed_image_standardization:<br />
        control_array += np.ones_like(labels_array)*facenet.FIXED_STANDARDIZATION<br />
    if use_flipped_images:<br />
        # Flip every second image<br />
        control_array += (labels_array % 2)*facenet.FLIP<br />
    sess.run(enqueue_op, {image_paths_placeholder: image_paths_array, labels_placeholder: labels_array, control_placeholder: control_array})

    embedding_size = int(embeddings.get_shape()[1])<br />
    assert nrof_images % batch_size == 0, 'The number of LFW images must be an integer multiple of the LFW batch size'<br />
    nrof_batches = nrof_images // batch_size<br />
    emb_array = np.zeros((nrof_images, embedding_size))<br />
    lab_array = np.zeros((nrof_images,))<br />
    for i in range(nrof_batches):<br />
        feed_dict = {phase_train_placeholder:False, batch_size_placeholder:batch_size}<br />
        emb, lab = sess.run([embeddings, labels], feed_dict=feed_dict)<br />
        lab_array[lab] = lab<br />
        emb_array[lab, :] = emb<br />
        if i % 10 == 9:<br />
            print('.', end='')<br />
            sys.stdout.flush()<br />
    print('')<br />
    embeddings = np.zeros((nrof_embeddings, embedding_size*nrof_flips))<br />
    if use_flipped_images:<br />
        # Concatenate embeddings for flipped and non flipped version of the images<br />
        embeddings[:,:embedding_size] = emb_array[0::2,:]<br />
        embeddings[:,embedding_size:] = emb_array[1::2,:]<br />
    else:<br />
        embeddings = emb_array

    assert np.array_equal(lab_array, np.arange(nrof_images))==True, 'Wrong labels used for evaluation, possibly caused by training examples left in the input pipeline'<br />
    tpr, fpr, accuracy, val, val_std, far = lfw.evaluate(embeddings, actual_issame, nrof_folds=nrof_folds, distance_metric=distance_metric, subtract_mean=subtract_mean)

    print('Accuracy: %2.5f+-%2.5f' % (np.mean(accuracy), np.std(accuracy)))<br />
    print('Validation rate: %2.5f+-%2.5f @ FAR=%2.5f' % (val, val_std, far))

    auc = metrics.auc(fpr, tpr)<br />
    print('Area Under Curve (AUC): %1.3f' % auc)<br />
    eer = brentq(lambda x: 1. - x - interpolate.interp1d(fpr, tpr)(x), 0., 1.)<br />
    print('Equal Error Rate (EER): %1.3f' % eer)

def parse_arguments(argv):<br />
    '''<br />
    参数解析<br />
    '''<br />
    parser = argparse.ArgumentParser()

    parser.add_argument('lfw_dir', type=str,<br />
        help='Path to the data directory containing aligned LFW face patches.')<br />
    parser.add_argument('--lfw_batch_size', type=int,<br />
        help='Number of images to process in a batch in the LFW test set.', default=100)<br />
    parser.add_argument('model', type=str,<br />
        help='Could be either a directory containing the meta_file and ckpt_file or a model protobuf (.pb) file')<br />
    parser.add_argument('--image_size', type=int,<br />
        help='Image size (height, width) in pixels.', default=160)<br />
    parser.add_argument('--lfw_pairs', type=str,<br />
        help='The file containing the pairs to use for validation.', default='data/pairs.txt')<br />
    parser.add_argument('--lfw_nrof_folds', type=int,<br />
        help='Number of folds to use for cross validation. Mainly used for testing.', default=10)<br />
    parser.add_argument('--distance_metric', type=int,<br />
        help='Distance metric  0:euclidian, 1:cosine similarity.', default=0)<br />
    parser.add_argument('--use_flipped_images',<br />
        help='Concatenates embeddings for the image and its horizontally flipped counterpart.', action='store_true')<br />
    parser.add_argument('--subtract_mean',<br />
        help='Subtract feature mean before calculating distance.', action='store_true')<br />
    parser.add_argument('--use_fixed_image_standardization',<br />
        help='Performs fixed standardization of images.', action='store_true')<br />
    return parser.parse_args(argv)

if __name__ == '__main__':<br />
    main(parse_arguments(sys.argv[1:]))</pre>
</div>
</div>
<ul><li>首先加载data/pairs.txt文件，该文件保存着测试使用的图片，其中有同一个人，以及不同人的图片对；</li>
<li>创建一个对象，使用TF的队列机制加载数据；</li>
<li>加载facenet模型；</li>
<li>启动QueueRunner，计算测试图片对的距离，根据距离(距离小于1为同一个人，否则相反)和实际标签来进行评估准确率；</li></ul>
<h4>5、在LFW数据集上使用已有模型</h4>
<p>在实际应用过程中，我们有时候还会关心如何在自己的图像上应用已有模型。下面我们以计算人脸之间的距离为例，演示如何将模型应用到自己的数据上。</p>
<p>假设我们现在有三张图片，我们把他们存放在facenet/src目录下，文件分别叫做img1.jpg,img2.jpg,img3.jpg。这三张图像中各包含有一个人的人脸，我们希望计算它们两两之间的距离。使用facenet/src/compare.py文件来实现。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001164517202-2054268848.png" /></p>
<p>我们打开Anaconda Prompt，来到facenet路径下(注意这里是facenet路径下)，运行如下命令：</p>
<div>
<pre class="prettyprint linenums">python src/compare.py models/20180408-102900 src/img1.jpg  src/img2.jpg src/img3.jpg  </pre>
</div>
<p>运行结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001162947519-2055536338.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001164539844-1573795525.png" /></p>
<p>我们尝试使用不同的三个人的图片进行测试：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001164620825-1555684807.png" /></p>
<div>
<pre class="prettyprint linenums">python src/compare.py models/20180408-102900 src/img3.jpg  src/img4.jpg src/img5.jpg  </pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001164813119-1285593827.png" /></p>
<p>我们会发现同一个人的图片，测试得到的距离值偏小，而不同的人测试得到的距离偏大。正常情况下同一个人测得距离应该小于1，不同人测得距离应该大于1。然而上面的结果却不是这样，我认为这多半与我们选取的照片有关。在选取测试照片时，我们尽量要选取脸部较为清晰并且端正的图片，并且要与训练数据具有相同分布的图片，即尽量选取一些外国人的图片进行测试。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001165412029-362074369.png" /></p>
<div>
<pre class="prettyprint linenums">python src/compare.py models/20180408-102900 src/img6.jpg  src/img7.jpg src/img8.jpg  </pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001165515916-1385309485.png" /></p>
<p>我们可以看到这个效果还是不错的，因此如果我们想在我们华人图片上也取得不错的效果，我们需要用华人的数据集进行训练模型。</p>
<p>compare.py源码如下：</p>
<div>
<div>
<pre class="prettyprint linenums">"""Performs face alignment and calculates L2 distance between the embeddings of images."""

# MIT License<br />
#<br />
# Copyright (c) 2016 David Sandberg<br />
#<br />
# Permission is hereby granted, free of charge, to any person obtaining a copy<br />
# of this software and associated documentation files (the "Software"), to deal<br />
# in the Software without restriction, including without limitation the rights<br />
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell<br />
# copies of the Software, and to permit persons to whom the Software is<br />
# furnished to do so, subject to the following conditions:<br />
#<br />
# The above copyright notice and this permission notice shall be included in all<br />
# copies or substantial portions of the Software.<br />
#<br />
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR<br />
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,<br />
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE<br />
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER<br />
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,<br />
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE<br />
# SOFTWARE.

from __future__ import absolute_import<br />
from __future__ import division<br />
from __future__ import print_function

from scipy import misc<br />
import tensorflow as tf<br />
import numpy as np<br />
import sys<br />
import os<br />
import copy<br />
import argparse<br />
import facenet<br />
import align.detect_face

def main(args):

    #使用MTCNN网络在原始图片中进行检测和对齐<br />
    images = load_and_align_data(args.image_files, args.image_size, args.margin, args.gpu_memory_fraction)

    with tf.Graph().as_default():

        with tf.Session() as sess:

            # Load the facenet  model<br />
            facenet.load_model(args.model)

            # Get input and output tensors<br />
            # 输入图像占位符<br />
            images_placeholder = tf.get_default_graph().get_tensor_by_name("input:0")<br />
            #卷及网络最后输出的"特征"<br />
            embeddings = tf.get_default_graph().get_tensor_by_name("embeddings:0")<br />
            #训练？<br />
            phase_train_placeholder = tf.get_default_graph().get_tensor_by_name("phase_train:0")

            # Run forward pass to calculate embeddings<br />
            feed_dict = { images_placeholder: images, phase_train_placeholder:False }<br />
            emb = sess.run(embeddings, feed_dict=feed_dict)

            nrof_images = len(args.image_files)

            print('Images:')<br />
            for i in range(nrof_images):<br />
                print('%1d: %s' % (i, args.image_files[i]))<br />
            print('')

            # Print distance matrix<br />
            print('Distance matrix')<br />
            print('    ', end='')<br />
            for i in range(nrof_images):<br />
                print('    %1d     ' % i, end='')<br />
            print('')<br />
            for i in range(nrof_images):<br />
                print('%1d  ' % i, end='')<br />
                for j in range(nrof_images):<br />
                    #对特征计算两两之间的距离以得到人脸之间的相似度<br />
                    dist = np.sqrt(np.sum(np.square(np.subtract(emb[i,:], emb[j,:]))))<br />
                    print('  %1.4f  ' % dist, end='')<br />
                print('')

def load_and_align_data(image_paths, image_size, margin, gpu_memory_fraction):<br />
    '''<br />
    返回经过MTCNN处理后的人脸图像集合 [n,160,160,3]<br />
    '''<br />
    minsize = 20 # minimum size of face<br />
    threshold = [ 0.6, 0.7, 0.7 ]  # three steps's threshold<br />
    factor = 0.709 # scale factor

    #创建P-Net,R-Net,O-Net网络，并加载参数<br />
    print('Creating networks and loading parameters')<br />
    with tf.Graph().as_default():<br />
        gpu_options = tf.GPUOptions(per_process_gpu_memory_fraction=gpu_memory_fraction)<br />
        sess = tf.Session(config=tf.ConfigProto(gpu_options=gpu_options, log_device_placement=False))<br />
        with sess.as_default():<br />
            pnet, rnet, onet = align.detect_face.create_mtcnn(sess, None)

    tmp_image_paths=copy.copy(image_paths)<br />
    img_list = []<br />
    #遍历测试图片<br />
    for image in tmp_image_paths:<br />
        img = misc.imread(os.path.expanduser(image), mode='RGB')<br />
        img_size = np.asarray(img.shape)[0:2]<br />
        #人脸检测 bounding_boxes：表示边界框 形状为[n,5] 5对应x1,y1,x2,y2,score<br />
        #_：人脸关键点坐标 形状为 [n,10]<br />
        bounding_boxes, _ = align.detect_face.detect_face(img, minsize, pnet, rnet, onet, threshold, factor)<br />
        if len(bounding_boxes) &lt; 1:<br />
          image_paths.remove(image)<br />
          print("can't detect face, remove ", image)<br />
          continue<br />
        #对图像进行处理:扩展、裁切、缩放<br />
        det = np.squeeze(bounding_boxes[0,0:4])<br />
        bb = np.zeros(4, dtype=np.int32)<br />
        bb[0] = np.maximum(det[0]-margin/2, 0)<br />
        bb[1] = np.maximum(det[1]-margin/2, 0)<br />
        bb[2] = np.minimum(det[2]+margin/2, img_size[1])<br />
        bb[3] = np.minimum(det[3]+margin/2, img_size[0])<br />
        cropped = img[bb[1]:bb[3],bb[0]:bb[2],:]<br />
        aligned = misc.imresize(cropped, (image_size, image_size), interp='bilinear')<br />
        #归一化处理<br />
        prewhitened = facenet.prewhiten(aligned)<br />
        img_list.append(prewhitened)<br />
    #[n,160,160,3]<br />
    images = np.stack(img_list)<br />
    return images

def parse_arguments(argv):<br />
    '''<br />
    参数解析<br />
    '''<br />
    parser = argparse.ArgumentParser()

    parser.add_argument('model', type=str,<br />
        help='Could be either a directory containing the meta_file and ckpt_file or a model protobuf (.pb) file')<br />
    parser.add_argument('image_files', type=str, nargs='+', help='Images to compare')<br />
    parser.add_argument('--image_size', type=int,<br />
        help='Image size (height, width) in pixels.', default=160)<br />
    parser.add_argument('--margin', type=int,<br />
        help='Margin for the crop around the bounding box (height, width) in pixels.', default=44)<br />
    parser.add_argument('--gpu_memory_fraction', type=float,<br />
        help='Upper bound on the amount of GPU memory that will be used by the process.', default=1.0)<br />
    return parser.parse_args(argv)

if __name__ == '__main__':<br />
    main(parse_arguments(sys.argv[1:]))</pre>
</div>
</div>
<ul><li>首先使用MTCNN网络对原始测试图片进行检测和对齐，即得到[n,160,160,3]的输出；</li>
<li>从模型文件(meta,ckpt文件)中加载facenet网络；</li>
<li>把处理后的测试图片输入网络，得到每个图像的特征，对特征计算两两之间的距离以得到人脸之间的相似度；</li></ul>
<h4>6、重新训练新模型</h4>
<p>从头训练一个新模型需要非常多的数据集，这里我们以CASIA-WebFace为例，这个 dataset 在原始地址已经下载不到了，而且这个 dataset 据说有很多无效的图片，所以这里我们使用的是清理过的数据库。该数据库可以在百度网盘有下载：<a href="http://pan.baidu.com/s/1kUdRRJT" rel="external nofollow noreferrer">下载地址</a>，提取密码为 3zbb；或者在如下网址下载<a href="https://download.csdn.net/download/dsbhgkrgherk/10228992" rel="external nofollow noreferrer">https://download.csdn.net/download/dsbhgkrgherk/10228992</a>。</p>
<p>这个数据库有 10575 个类别494414张图像，每个类别都有各自的文件夹，里面有同一个人的几张或者几十张不等的脸部图片。我们先利用MTCNN 从这些照片中把人物的脸框出来，然后交给下面的 Facenet 去训练。</p>
<p>下载好之后，解压到datasets/casia/raw目录下，如图：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181001195058058-857061659.png" /></p>
<p>其中每个文件夹代表一个人，文件夹保存这个人的所有人脸图片。与LFW数据集类似，我们先利用MTCNN对原始图像进行人脸检测和对齐，我们打开Anaconda Prompt，来到facenet路径下，运行如下命令：</p>
<div>
<pre class="prettyprint linenums">python  src/align/align_dataset_mtcnn.py   ../datasets/casia/raw  ../datasets/casia/casia_maxpy_mtcnnpy_182 --image_size 182 --margin 44 --random_order</pre>
</div>
<p>对齐后的图像保存在路径datasets/casia/casia_maxpy_mtcnnpy_182下，每张图像的大小都是$182\times{182}$。而最终网络的输入是$160\times{160}$，之所以先生成$182\times{182}$的图像，是为了留出一定的空间给数据增强的裁切环节。我们会在$182\times{182}$的图像上随机裁切出$160\times{160}$的区域，再送入神经网络进行训练。</p>
<p>使用如下命令开始训练：</p>
<div>
<pre class="prettyprint linenums">python src/train_softmax.py --logs_base_dir ./logs  --models_base_dir  ./models  --data_dir ../datasets/casia/casia_maxpy_mtcnnpy_182  --image_size  --model_def models.inception_resnet_v1 --lfw_dir ../datasets/lfw/lfw_mtcnnpy_160 --optimizer RMSPROP --learning_rate - --max_nrof_epochs  --keep_probability 0.8  --random_crop --random_flip --learning_rate_schedule_file data/learning_rate_schedule_classifier_casia.txt  --weight_decay 5e- --center_loss_factor 1e- --center_loss_alfa 0.9</pre>
</div>
<p>上面命令中有很多参数，我们来一一介绍。首先是文件src/train_softmax.py文件，它采用中心损失和softmax损失结合来训练模型，其中参数如下：</p>
<ul><li>--logs_base_dir./logs：将会把训练日志保存到./logs中，在运行时，会在./logs文件夹下新建一个以当前时间命名的文讲夹。最终的日志会保存在这个文件夹中，所谓的日志文件，实际上指的是tf中的events文件，它主要包含当前损失、当前训练步数、当前学习率等信息。后面我们会使用TensorBoard查看这些信息；</li>
<li>--models_base_dir ./models：最终训练好的模型保存在./models文件夹下，在运行时，会在./models文件夹下新建一个以当前时间命名的文讲夹，并用来保存训练好的模型；</li>
<li>--data_dir ../datasets/casis/casia_maxpy_mtcnnpy_182：指定训练所使用的数据集的路径，这里使用的就是刚才对齐好的CASIA-WebFace人脸数据；</li>
<li>--image_size 160：输入网络的图片尺寸是$160\times{160}$大小；</li>
<li>--mode_def models.inception_resnet_v1：指定了训练所使用的卷积网络是inception_resnet_v1网络。项目所支持的网络在src/models目录下，包含inception_resnet_v1，inception_resnet_v2和squeezenet三个模型，前两个模型较大，最后一个模型较小。如果在训练时出现内存或者显存不足的情况可以尝试使用sequeezenet网络，也可以修改batch_size 大小为32或者64(默认是90)；</li>
<li>--lfw_dir&nbsp; ../datasets/lfw/lfw_mtcnnpy_160：指定了LFW数据集的路径。如果指定了这个参数，那么每训练完一个epoch，就会在LFW数据集上执行一次测试，并将测试的准确率写入到日志文件中；</li>
<li>--optimizer RMSPROP ：指定训练使用的优化方法；</li>
<li>--learning_rate&nbsp; -1：指定学习率，指定了负数表示忽略这个参数，而使用后面的--learning_rate_schedule_file参数规划学习率；</li>
<li>--max_nrof_epochs 80：指定训练轮数epoch；</li>
<li>--keep_probability 0.8：指定弃权的神经元保留率；</li>
<li>--random_crop：表明在数据增强时使用随机裁切；</li>
<li>--random_flip ：表明在数据增强时使用随机随机翻转；</li>
<li>--learning_rate_schedule_file data/learning_rate_schedule_classifier_casia.txt：在之前指定了--learning_rate&nbsp; -1，因此最终的学习率将由参数--learning_rate_schedule_file决定。这个参数指定一个文件data/learning_rate_schedule_classifier_casia.txt，该文件内容如下：
<div>
<pre class="prettyprint linenums"># Learning rate schedule<br />
# Maps an epoch number to a learning rate<br />
:  0.05<br />
: 0.005<br />
: 0.0005<br />
: -</pre>
</div></li>
<li>--weight_decay 5e-5：正则化系数；</li>
<li>--center_loss_factor 1e-2 ：中心损失和Softmax损失的平衡系数；</li>
<li>--center_loss_alfa 0.9：中心损失的内部参数；</li></ul>
<p>除了上面我们使用到的参数，还有许多参数，下面介绍一些比较重要的：</p>
<ul><li>pretrained_model ：models/20180408-102900&nbsp; 预训练模型，使用预训练模型可以加快训练速度(微调时经常使用到)；</li>
<li>batch_size：batch大小，越大，需要的内存也会越大；</li>
<li>random_rotate：表明在数据增强时使用随机旋转；</li></ul>
<p>由于CASIA-WebFace数据集比较大、训练起来周期较长，下面我们使用CASIA-WebFace一部分数据进行训练，运行结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181007215204238-613470500.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181007212231661-668292827.png" /></p>
<p>其中Epoch：[32][683/1000]表示当前为第32个epoch以及当前epoch内的第683个训练batch，程序中默认参数epoch_size为1000，表示一个epoch有1000个batch。Time表示这一步的消耗的时间，Lr是学习率，Loss为当前batch的损失，Xent是softmax损失，RegLoss是正则化损失和中心损失之和，Cl是中心损失(注意这里的损失都是平均损失，即当前batch损失和/batch_size)；</p>
<p>生成日志文件和模型文件：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181007224502120-320499829.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181007224520109-2125877621.png" /></p>
<p>我们启动Anaconda Prompt，首先来到日志文件的上级路径下，这一步是必须的，然后输入如下命令：</p>
<div>
<pre class="prettyprint linenums">tensorboard --logdir E:\program\facenet\logs\20181007-12244</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181007225808731-142481863.png" /></p>
<p>接着打开浏览器，输入http://127.0.0.1:6006,这里127.0.0.1是本机地址，6006是端口号。打开后，单击SCALARS，我们会看到我们在程序中创建的变量total_loss_1，点击它，会显示如下内容：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181007230954202-950047852.png" /></p>
<p>上图为训练过程中损失函数的变化过程，横坐标为迭代步数，这里为33k左右，主要是因为我迭代了33个epoch后终止了程序，每个epoch又迭代1000个batch。</p>
<p>与之对应的，每个epoch结束还会在LFW数据集上做一次验证，对应的准确率变化曲线如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1328274/201810/1328274-20181007231720635-360645388.png" /></p>
<p>在左侧有个smoothing滚动条，可以用来改变右侧标量的曲线，我们还可以勾选上show data download links，然后下载数据。</p>
<p>train_softmax.py源码如下：</p>
<div>
<div>
<pre class="prettyprint linenums">"""Training a face recognizer with TensorFlow using softmax cross entropy loss<br />
"""<br />
# MIT License<br />
#<br />
# Copyright (c) 2016 David Sandberg<br />
#<br />
# Permission is hereby granted, free of charge, to any person obtaining a copy<br />
# of this software and associated documentation files (the "Software"), to deal<br />
# in the Software without restriction, including without limitation the rights<br />
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell<br />
# copies of the Software, and to permit persons to whom the Software is<br />
# furnished to do so, subject to the following conditions:<br />
#<br />
# The above copyright notice and this permission notice shall be included in all<br />
# copies or substantial portions of the Software.<br />
#<br />
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR<br />
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,<br />
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE<br />
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER<br />
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,<br />
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE<br />
# SOFTWARE.

from __future__ import absolute_import<br />
from __future__ import division<br />
from __future__ import print_function

from datetime import datetime<br />
import os.path<br />
import time<br />
import sys<br />
import random<br />
import tensorflow as tf<br />
import numpy as np<br />
import importlib<br />
import argparse<br />
import facenet<br />
import lfw<br />
import h5py<br />
import math<br />
import tensorflow.contrib.slim as slim<br />
from tensorflow.python.ops import data_flow_ops<br />
from tensorflow.python.framework import ops<br />
from tensorflow.python.ops import array_ops

def main(args):<br />
    #导入CNN网络模块<br />
    network = importlib.import_module(args.model_def)<br />
    image_size = (args.image_size, args.image_size)

    #当前时间<br />
    subdir = datetime.strftime(datetime.now(), '%Y%m%d-%H%M%S')<br />
    #日志文件夹路径<br />
    log_dir = os.path.join(os.path.expanduser(args.logs_base_dir), subdir)<br />
    if not os.path.isdir(log_dir):  # Create the log directory if it doesn't exist<br />
        os.makedirs(log_dir)<br />
    #模型文件夹路径<br />
    model_dir = os.path.join(os.path.expanduser(args.models_base_dir), subdir)<br />
    if not os.path.isdir(model_dir):  # Create the model directory if it doesn't exist<br />
        os.makedirs(model_dir)

    stat_file_name = os.path.join(log_dir, 'stat.h5')

    # Write arguments to a text file<br />
    facenet.write_arguments_to_file(args, os.path.join(log_dir, 'arguments.txt'))

    # Store some git revision info in a text file in the log directory<br />
    src_path,_ = os.path.split(os.path.realpath(__file__))<br />
    facenet.store_revision_info(src_path, log_dir, ' '.join(sys.argv))

    np.random.seed(seed=args.seed)<br />
    random.seed(args.seed)<br />
    #训练数据集准备工作：获取每个类别名称以及该类别下所有图片的绝对路径<br />
    dataset = facenet.get_dataset(args.data_dir)<br />
    if args.filter_filename:<br />
        dataset = filter_dataset(dataset, os.path.expanduser(args.filter_filename),<br />
            args.filter_percentile, args.filter_min_nrof_images_per_class)

    if args.validation_set_split_ratio&gt;0.0:<br />
        train_set, val_set = facenet.split_dataset(dataset, args.validation_set_split_ratio, args.min_nrof_val_images_per_class, 'SPLIT_IMAGES')<br />
    else:<br />
        train_set, val_set = dataset, []

    #类别个数 每一个人都是一个类别<br />
    nrof_classes = len(train_set)

    print('Model directory: %s' % model_dir)<br />
    print('Log directory: %s' % log_dir)<br />
    #指定了预训练模型？<br />
    pretrained_model = None<br />
    if args.pretrained_model:<br />
        pretrained_model = os.path.expanduser(args.pretrained_model)<br />
        print('Pre-trained model: %s' % pretrained_model)<br />
    #指定了lfw数据集路径？用于测试<br />
    if args.lfw_dir:<br />
        print('LFW directory: %s' % args.lfw_dir)<br />
        # Read the file containing the pairs used for testing<br />
        pairs = lfw.read_pairs(os.path.expanduser(args.lfw_pairs))<br />
        # Get the paths for the corresponding images<br />
        lfw_paths, actual_issame = lfw.get_paths(os.path.expanduser(args.lfw_dir), pairs)

    with tf.Graph().as_default():<br />
        tf.set_random_seed(args.seed)<br />
        #训练步数<br />
        global_step = tf.Variable(0, trainable=False)

        # Get a list of image paths and their labels<br />
        # image_list：list 每一个元素对应一个图像的路径<br />
        # label_list：list 每一个元素对应一个图像的标签 使用0,1,2...表示<br />
        image_list, label_list = facenet.get_image_paths_and_labels(train_set)<br />
        assert len(image_list)&gt;0, 'The training set should not be empty'

        val_image_list, val_label_list = facenet.get_image_paths_and_labels(val_set)

        # Create a queue that produces indices into the image_list and label_list<br />
        labels = ops.convert_to_tensor(label_list, dtype=tf.int32)<br />
        #图像个数<br />
        range_size = array_ops.shape(labels)[0]<br />
        #创建一个索引队列，队列产生0到range_size-1的元素<br />
        index_queue = tf.train.range_input_producer(range_size, num_epochs=None,<br />
                             shuffle=True, seed=None, capacity=32)<br />
        #每次出队args.batch_size*args.epoch_size个元素 即一个epoch样本数<br />
        index_dequeue_op = index_queue.dequeue_many(args.batch_size*args.epoch_size, 'index_dequeue')

        #定义占位符<br />
        learning_rate_placeholder = tf.placeholder(tf.float32, name='learning_rate')<br />
        batch_size_placeholder = tf.placeholder(tf.int32, name='batch_size')<br />
        phase_train_placeholder = tf.placeholder(tf.bool, name='phase_train')<br />
        image_paths_placeholder = tf.placeholder(tf.string, shape=(None,1), name='image_paths')<br />
        labels_placeholder = tf.placeholder(tf.int32, shape=(None,1), name='labels')<br />
        control_placeholder = tf.placeholder(tf.int32, shape=(None,1), name='control')

        #新建一个队列，数据流操作，fifo，队列中每一项包含一个输入图像路径和相应的标签、control  shapes:对应的是每一项输入的形状<br />
        nrof_preprocess_threads = 4<br />
        input_queue = data_flow_ops.FIFOQueue(capacity=2000000,<br />
                                    dtypes=[tf.string, tf.int32, tf.int32],<br />
                                    shapes=[(1,), (1,), (1,)],<br />
                                    shared_name=None, name=None)<br />
        #返回一个入队操作<br />
        enqueue_op = input_queue.enqueue_many([image_paths_placeholder, labels_placeholder, control_placeholder], name='enqueue_op')<br />
        #返回一个出队操作，即每次训练获取batch大小的数据<br />
        image_batch, label_batch = facenet.create_input_pipeline(input_queue, image_size, nrof_preprocess_threads, batch_size_placeholder)

        #复制副本<br />
        image_batch = tf.identity(image_batch, 'image_batch')<br />
        image_batch = tf.identity(image_batch, 'input')<br />
        label_batch = tf.identity(label_batch, 'label_batch')

        print('Number of classes in training set: %d' % nrof_classes)<br />
        print('Number of examples in training set: %d' % len(image_list))

        print('Number of classes in validation set: %d' % len(val_set))<br />
        print('Number of examples in validation set: %d' % len(val_image_list))

        print('Building training graph')

        # Build the inference graph<br />
        #创建CNN网络，最后一层输出 prelogits：[batch_size,128]<br />
        prelogits, _ = network.inference(image_batch, args.keep_probability,<br />
            phase_train=phase_train_placeholder, bottleneck_layer_size=args.embedding_size,<br />
            weight_decay=args.weight_decay)<br />
        #输出每个类别的概率 [batch_size,人数]<br />
        logits = slim.fully_connected(prelogits, len(train_set), activation_fn=None,<br />
                weights_initializer=slim.initializers.xavier_initializer(),<br />
                weights_regularizer=slim.l2_regularizer(args.weight_decay),<br />
                scope='Logits', reuse=False)

        #先计算每一行的l2范数，然后对每一行的元素/该行范数<br />
        embeddings = tf.nn.l2_normalize(prelogits, 1, 1e-10, name='embeddings')

        # Norm for the prelogits<br />
        eps = 1e-4<br />
        #默认prelogits先求绝对值，然后沿axis=1求1范数，最后求平均<br />
        prelogits_norm = tf.reduce_mean(tf.norm(tf.abs(prelogits)+eps, ord=args.prelogits_norm_p, axis=1))<br />
        #把变量prelogits_norm * args.prelogits_norm_loss_factor放入tf.GraphKeys.REGULARIZATION_LOSSES集合<br />
        tf.add_to_collection(tf.GraphKeys.REGULARIZATION_LOSSES, prelogits_norm * args.prelogits_norm_loss_factor)

        # Add center loss 计算中心损失，并追加到tf.GraphKeys.REGULARIZATION_LOSSES集合<br />
        prelogits_center_loss, _ = facenet.center_loss(prelogits, label_batch, args.center_loss_alfa, nrof_classes)<br />
        tf.add_to_collection(tf.GraphKeys.REGULARIZATION_LOSSES, prelogits_center_loss * args.center_loss_factor)

        #学习率指数衰减<br />
        learning_rate = tf.train.exponential_decay(learning_rate_placeholder, global_step,<br />
            args.learning_rate_decay_epochs*args.epoch_size, args.learning_rate_decay_factor, staircase=True)<br />
        tf.summary.scalar('learning_rate', learning_rate)

        # Calculate the average cross entropy loss across the batch<br />
        cross_entropy = tf.nn.sparse_softmax_cross_entropy_with_logits(<br />
            labels=label_batch, logits=logits, name='cross_entropy_per_example')<br />
        cross_entropy_mean = tf.reduce_mean(cross_entropy, name='cross_entropy')<br />
        #加入交叉熵代价函数<br />
        tf.add_to_collection('losses', cross_entropy_mean)

        #计算准确率 correct_prediction:[batch_size,1]<br />
        correct_prediction = tf.cast(tf.equal(tf.argmax(logits, 1), tf.cast(label_batch, tf.int64)), tf.float32)<br />
        accuracy = tf.reduce_mean(correct_prediction)

        # Calculate the total losses  https://blog.csdn.net/uestc_c2_403/article/details/72415791<br />
        regularization_losses = tf.get_collection(tf.GraphKeys.REGULARIZATION_LOSSES)<br />
        total_loss = tf.add_n([cross_entropy_mean] + regularization_losses, name='total_loss')

        # Build a Graph that trains the model with one batch of examples and updates the model parameters<br />
        train_op = facenet.train(total_loss, global_step, args.optimizer,<br />
            learning_rate, args.moving_average_decay, tf.global_variables(), args.log_histograms)

        # Create a saver<br />
        saver = tf.train.Saver(tf.trainable_variables(), max_to_keep=3)

        # Build the summary operation based on the TF collection of Summaries.<br />
        summary_op = tf.summary.merge_all()

        # Start running operations on the Graph.<br />
        gpu_options = tf.GPUOptions(per_process_gpu_memory_fraction=args.gpu_memory_fraction)<br />
        sess = tf.Session(config=tf.ConfigProto(gpu_options=gpu_options, log_device_placement=False))<br />
        sess.run(tf.global_variables_initializer())<br />
        sess.run(tf.local_variables_initializer())<br />
        summary_writer = tf.summary.FileWriter(log_dir, sess.graph)<br />
        #创建一个协调器，管理线程<br />
        coord = tf.train.Coordinator()<br />
        #启动start_queue_runners之后, 才会开始填充文件队列、并读取数据<br />
        tf.train.start_queue_runners(coord=coord, sess=sess)

        #开始执行图<br />
        with sess.as_default():<br />
            #加载预训练模型<br />
            if pretrained_model:<br />
                print('Restoring pretrained model: %s' % pretrained_model)<br />
                saver.restore(sess, pretrained_model)

            # Training and validation loop<br />
            print('Running training')<br />
            nrof_steps = args.max_nrof_epochs*args.epoch_size<br />
            nrof_val_samples = int(math.ceil(args.max_nrof_epochs / args.validate_every_n_epochs))   # Validate every validate_every_n_epochs as well as in the last epoch<br />
            stat = {<br />
                'loss': np.zeros((nrof_steps,), np.float32),<br />
                'center_loss': np.zeros((nrof_steps,), np.float32),<br />
                'reg_loss': np.zeros((nrof_steps,), np.float32),<br />
                'xent_loss': np.zeros((nrof_steps,), np.float32),<br />
                'prelogits_norm': np.zeros((nrof_steps,), np.float32),<br />
                'accuracy': np.zeros((nrof_steps,), np.float32),<br />
                'val_loss': np.zeros((nrof_val_samples,), np.float32),<br />
                'val_xent_loss': np.zeros((nrof_val_samples,), np.float32),<br />
                'val_accuracy': np.zeros((nrof_val_samples,), np.float32),<br />
                'lfw_accuracy': np.zeros((args.max_nrof_epochs,), np.float32),<br />
                'lfw_valrate': np.zeros((args.max_nrof_epochs,), np.float32),<br />
                'learning_rate': np.zeros((args.max_nrof_epochs,), np.float32),<br />
                'time_train': np.zeros((args.max_nrof_epochs,), np.float32),<br />
                'time_validate': np.zeros((args.max_nrof_epochs,), np.float32),<br />
                'time_evaluate': np.zeros((args.max_nrof_epochs,), np.float32),<br />
                'prelogits_hist': np.zeros((args.max_nrof_epochs, 1000), np.float32),<br />
              }<br />
            #开始迭代 epochs轮<br />
            for epoch in range(1,args.max_nrof_epochs+1):<br />
                step = sess.run(global_step, feed_dict=None)<br />
                # Train for one epoch<br />
                t = time.time()<br />
                cont = train(args, sess, epoch, image_list, label_list, index_dequeue_op, enqueue_op, image_paths_placeholder, labels_placeholder,<br />
                    learning_rate_placeholder, phase_train_placeholder, batch_size_placeholder, control_placeholder, global_step,<br />
                    total_loss, train_op, summary_op, summary_writer, regularization_losses, args.learning_rate_schedule_file,<br />
                    stat, cross_entropy_mean, accuracy, learning_rate,<br />
                    prelogits, prelogits_center_loss, args.random_rotate, args.random_crop, args.random_flip, prelogits_norm, args.prelogits_hist_max, args.use_fixed_image_standardization)<br />
                stat['time_train'][epoch-1] = time.time() - t

                if not cont:<br />
                    break

                t = time.time()<br />
                if len(val_image_list)&gt;0 and ((epoch-1) % args.validate_every_n_epochs == args.validate_every_n_epochs-1 or epoch==args.max_nrof_epochs):<br />
                    validate(args, sess, epoch, val_image_list, val_label_list, enqueue_op, image_paths_placeholder, labels_placeholder, control_placeholder,<br />
                        phase_train_placeholder, batch_size_placeholder,<br />
                        stat, total_loss, regularization_losses, cross_entropy_mean, accuracy, args.validate_every_n_epochs, args.use_fixed_image_standardization)<br />
                stat['time_validate'][epoch-1] = time.time() - t

                # Save variables and the metagraph if it doesn't exist already<br />
                save_variables_and_metagraph(sess, saver, summary_writer, model_dir, subdir, epoch)

                # Evaluate on LFW<br />
                t = time.time()<br />
                if args.lfw_dir:<br />
                    evaluate(sess, enqueue_op, image_paths_placeholder, labels_placeholder, phase_train_placeholder, batch_size_placeholder, control_placeholder,<br />
                        embeddings, label_batch, lfw_paths, actual_issame, args.lfw_batch_size, args.lfw_nrof_folds, log_dir, step, summary_writer, stat, epoch,<br />
                        args.lfw_distance_metric, args.lfw_subtract_mean, args.lfw_use_flipped_images, args.use_fixed_image_standardization)<br />
                stat['time_evaluate'][epoch-1] = time.time() - t

                print('Saving statistics')<br />
                with h5py.File(stat_file_name, 'w') as f:<br />
                    for key, value in stat.items():<br />
                        f.create_dataset(key, data=value)

    return model_dir

def find_threshold(var, percentile):<br />
    hist, bin_edges = np.histogram(var, 100)<br />
    cdf = np.float32(np.cumsum(hist)) / np.sum(hist)<br />
    bin_centers = (bin_edges[:-1]+bin_edges[1:])/2<br />
    #plt.plot(bin_centers, cdf)<br />
    threshold = np.interp(percentile*0.01, cdf, bin_centers)<br />
    return threshold

def filter_dataset(dataset, data_filename, percentile, min_nrof_images_per_class):<br />
    with h5py.File(data_filename,'r') as f:<br />
        distance_to_center = np.array(f.get('distance_to_center'))<br />
        label_list = np.array(f.get('label_list'))<br />
        image_list = np.array(f.get('image_list'))<br />
        distance_to_center_threshold = find_threshold(distance_to_center, percentile)<br />
        indices = np.where(distance_to_center&gt;=distance_to_center_threshold)[0]<br />
        filtered_dataset = dataset<br />
        removelist = []<br />
        for i in indices:<br />
            label = label_list[i]<br />
            image = image_list[i]<br />
            if image in filtered_dataset[label].image_paths:<br />
                filtered_dataset[label].image_paths.remove(image)<br />
            if len(filtered_dataset[label].image_paths)&lt;min_nrof_images_per_class:<br />
                removelist.append(label)

        ix = sorted(list(set(removelist)), reverse=True)<br />
        for i in ix:<br />
            del(filtered_dataset[i])

    return filtered_dataset

def train(args, sess, epoch, image_list, label_list, index_dequeue_op, enqueue_op, image_paths_placeholder, labels_placeholder,<br />
      learning_rate_placeholder, phase_train_placeholder, batch_size_placeholder, control_placeholder, step,<br />
      loss, train_op, summary_op, summary_writer, reg_losses, learning_rate_schedule_file,<br />
      stat, cross_entropy_mean, accuracy,<br />
      learning_rate, prelogits, prelogits_center_loss, random_rotate, random_crop, random_flip, prelogits_norm, prelogits_hist_max, use_fixed_image_standardization):<br />
    batch_number = 0

    if args.learning_rate&gt;0.0:<br />
        lr = args.learning_rate<br />
    else:<br />
        lr = facenet.get_learning_rate_from_file(learning_rate_schedule_file, epoch)

    if lr&lt;=0:<br />
        return False 

    #一个epoch，batch_size*epoch_size个样本<br />
    index_epoch = sess.run(index_dequeue_op)<br />
    label_epoch = np.array(label_list)[index_epoch]<br />
    image_epoch = np.array(image_list)[index_epoch]

    # Enqueue one epoch of image paths and labels<br />
    labels_array = np.expand_dims(np.array(label_epoch),1)<br />
    image_paths_array = np.expand_dims(np.array(image_epoch),1)<br />
    control_value = facenet.RANDOM_ROTATE * random_rotate + facenet.RANDOM_CROP * random_crop + facenet.RANDOM_FLIP * random_flip + facenet.FIXED_STANDARDIZATION * use_fixed_image_standardization<br />
    control_array = np.ones_like(labels_array) * control_value<br />
    sess.run(enqueue_op, {image_paths_placeholder: image_paths_array, labels_placeholder: labels_array, control_placeholder: control_array})

    # Training loop  一个epoch<br />
    train_time = 0<br />
    while batch_number &lt; args.epoch_size:<br />
        start_time = time.time()<br />
        feed_dict = {learning_rate_placeholder: lr, phase_train_placeholder:True, batch_size_placeholder:args.batch_size}<br />
        tensor_list = [loss, train_op, step, reg_losses, prelogits, cross_entropy_mean, learning_rate, prelogits_norm, accuracy, prelogits_center_loss]<br />
        if batch_number % 100 == 0:<br />
            loss_, _, step_, reg_losses_, prelogits_, cross_entropy_mean_, lr_, prelogits_norm_, accuracy_, center_loss_, summary_str = sess.run(tensor_list + [summary_op], feed_dict=feed_dict)<br />
            summary_writer.add_summary(summary_str, global_step=step_)<br />
        else:<br />
            loss_, _, step_, reg_losses_, prelogits_, cross_entropy_mean_, lr_, prelogits_norm_, accuracy_, center_loss_ = sess.run(tensor_list, feed_dict=feed_dict)

        duration = time.time() - start_time<br />
        stat['loss'][step_-1] = loss_<br />
        stat['center_loss'][step_-1] = center_loss_<br />
        stat['reg_loss'][step_-1] = np.sum(reg_losses_)<br />
        stat['xent_loss'][step_-1] = cross_entropy_mean_<br />
        stat['prelogits_norm'][step_-1] = prelogits_norm_<br />
        stat['learning_rate'][epoch-1] = lr_<br />
        stat['accuracy'][step_-1] = accuracy_<br />
        stat['prelogits_hist'][epoch-1,:] += np.histogram(np.minimum(np.abs(prelogits_), prelogits_hist_max), bins=1000, range=(0.0, prelogits_hist_max))[0]

        duration = time.time() - start_time<br />
        print('Epoch: [%d][%d/%d]\tTime %.3f\tLoss %2.3f\tXent %2.3f\tRegLoss %2.3f\tAccuracy %2.3f\tLr %2.5f\tCl %2.3f' %<br />
              (epoch, batch_number+1, args.epoch_size, duration, loss_, cross_entropy_mean_, np.sum(reg_losses_), accuracy_, lr_, center_loss_))<br />
        batch_number += 1<br />
        train_time += duration<br />
    # Add validation loss and accuracy to summary<br />
    summary = tf.Summary()<br />
    #pylint: disable=maybe-no-member<br />
    summary.value.add(tag='time/total', simple_value=train_time)<br />
    summary_writer.add_summary(summary, global_step=step_)<br />
    return True

def validate(args, sess, epoch, image_list, label_list, enqueue_op, image_paths_placeholder, labels_placeholder, control_placeholder,<br />
             phase_train_placeholder, batch_size_placeholder,<br />
             stat, loss, regularization_losses, cross_entropy_mean, accuracy, validate_every_n_epochs, use_fixed_image_standardization):

    print('Running forward pass on validation set')

    nrof_batches = len(label_list) // args.lfw_batch_size<br />
    nrof_images = nrof_batches * args.lfw_batch_size

    # Enqueue one epoch of image paths and labels<br />
    labels_array = np.expand_dims(np.array(label_list[:nrof_images]),1)<br />
    image_paths_array = np.expand_dims(np.array(image_list[:nrof_images]),1)<br />
    control_array = np.ones_like(labels_array, np.int32)*facenet.FIXED_STANDARDIZATION * use_fixed_image_standardization<br />
    sess.run(enqueue_op, {image_paths_placeholder: image_paths_array, labels_placeholder: labels_array, control_placeholder: control_array})

    loss_array = np.zeros((nrof_batches,), np.float32)<br />
    xent_array = np.zeros((nrof_batches,), np.float32)<br />
    accuracy_array = np.zeros((nrof_batches,), np.float32)

    # Training loop<br />
    start_time = time.time()<br />
    for i in range(nrof_batches):<br />
        feed_dict = {phase_train_placeholder:False, batch_size_placeholder:args.lfw_batch_size}<br />
        loss_, cross_entropy_mean_, accuracy_ = sess.run([loss, cross_entropy_mean, accuracy], feed_dict=feed_dict)<br />
        loss_array[i], xent_array[i], accuracy_array[i] = (loss_, cross_entropy_mean_, accuracy_)<br />
        if i % 10 == 9:<br />
            print('.', end='')<br />
            sys.stdout.flush()<br />
    print('')

    duration = time.time() - start_time

    val_index = (epoch-1)//validate_every_n_epochs<br />
    stat['val_loss'][val_index] = np.mean(loss_array)<br />
    stat['val_xent_loss'][val_index] = np.mean(xent_array)<br />
    stat['val_accuracy'][val_index] = np.mean(accuracy_array)

    print('Validation Epoch: %d\tTime %.3f\tLoss %2.3f\tXent %2.3f\tAccuracy %2.3f' %<br />
          (epoch, duration, np.mean(loss_array), np.mean(xent_array), np.mean(accuracy_array)))

def evaluate(sess, enqueue_op, image_paths_placeholder, labels_placeholder, phase_train_placeholder, batch_size_placeholder, control_placeholder,<br />
        embeddings, labels, image_paths, actual_issame, batch_size, nrof_folds, log_dir, step, summary_writer, stat, epoch, distance_metric, subtract_mean, use_flipped_images, use_fixed_image_standardization):<br />
    start_time = time.time()<br />
    # Run forward pass to calculate embeddings<br />
    print('Runnning forward pass on LFW images')

    # Enqueue one epoch of image paths and labels<br />
    nrof_embeddings = len(actual_issame)*2  # nrof_pairs * nrof_images_per_pair<br />
    nrof_flips = 2 if use_flipped_images else 1<br />
    nrof_images = nrof_embeddings * nrof_flips<br />
    labels_array = np.expand_dims(np.arange(0,nrof_images),1)<br />
    image_paths_array = np.expand_dims(np.repeat(np.array(image_paths),nrof_flips),1)<br />
    control_array = np.zeros_like(labels_array, np.int32)<br />
    if use_fixed_image_standardization:<br />
        control_array += np.ones_like(labels_array)*facenet.FIXED_STANDARDIZATION<br />
    if use_flipped_images:<br />
        # Flip every second image<br />
        control_array += (labels_array % 2)*facenet.FLIP<br />
    sess.run(enqueue_op, {image_paths_placeholder: image_paths_array, labels_placeholder: labels_array, control_placeholder: control_array})

    embedding_size = int(embeddings.get_shape()[1])<br />
    assert nrof_images % batch_size == 0, 'The number of LFW images must be an integer multiple of the LFW batch size'<br />
    nrof_batches = nrof_images // batch_size<br />
    emb_array = np.zeros((nrof_images, embedding_size))<br />
    lab_array = np.zeros((nrof_images,))<br />
    for i in range(nrof_batches):<br />
        feed_dict = {phase_train_placeholder:False, batch_size_placeholder:batch_size}<br />
        emb, lab = sess.run([embeddings, labels], feed_dict=feed_dict)<br />
        lab_array[lab] = lab<br />
        emb_array[lab, :] = emb<br />
        if i % 10 == 9:<br />
            print('.', end='')<br />
            sys.stdout.flush()<br />
    print('')<br />
    embeddings = np.zeros((nrof_embeddings, embedding_size*nrof_flips))<br />
    if use_flipped_images:<br />
        # Concatenate embeddings for flipped and non flipped version of the images<br />
        embeddings[:,:embedding_size] = emb_array[0::2,:]<br />
        embeddings[:,embedding_size:] = emb_array[1::2,:]<br />
    else:<br />
        embeddings = emb_array

    assert np.array_equal(lab_array, np.arange(nrof_images))==True, 'Wrong labels used for evaluation, possibly caused by training examples left in the input pipeline'<br />
    _, _, accuracy, val, val_std, far = lfw.evaluate(embeddings, actual_issame, nrof_folds=nrof_folds, distance_metric=distance_metric, subtract_mean=subtract_mean)

    print('Accuracy: %2.5f+-%2.5f' % (np.mean(accuracy), np.std(accuracy)))<br />
    print('Validation rate: %2.5f+-%2.5f @ FAR=%2.5f' % (val, val_std, far))<br />
    lfw_time = time.time() - start_time<br />
    # Add validation loss and accuracy to summary<br />
    summary = tf.Summary()<br />
    #pylint: disable=maybe-no-member<br />
    summary.value.add(tag='lfw/accuracy', simple_value=np.mean(accuracy))<br />
    summary.value.add(tag='lfw/val_rate', simple_value=val)<br />
    summary.value.add(tag='time/lfw', simple_value=lfw_time)<br />
    summary_writer.add_summary(summary, step)<br />
    with open(os.path.join(log_dir,'lfw_result.txt'),'at') as f:<br />
        f.write('%d\t%.5f\t%.5f\n' % (step, np.mean(accuracy), val))<br />
    stat['lfw_accuracy'][epoch-1] = np.mean(accuracy)<br />
    stat['lfw_valrate'][epoch-1] = val

def save_variables_and_metagraph(sess, saver, summary_writer, model_dir, model_name, step):<br />
    # Save the model checkpoint<br />
    print('Saving variables')<br />
    start_time = time.time()<br />
    checkpoint_path = os.path.join(model_dir, 'model-%s.ckpt' % model_name)<br />
    saver.save(sess, checkpoint_path, global_step=step, write_meta_graph=False)<br />
    save_time_variables = time.time() - start_time<br />
    print('Variables saved in %.2f seconds' % save_time_variables)<br />
    metagraph_filename = os.path.join(model_dir, 'model-%s.meta' % model_name)<br />
    save_time_metagraph = 0<br />
    if not os.path.exists(metagraph_filename):<br />
        print('Saving metagraph')<br />
        start_time = time.time()<br />
        saver.export_meta_graph(metagraph_filename)<br />
        save_time_metagraph = time.time() - start_time<br />
        print('Metagraph saved in %.2f seconds' % save_time_metagraph)<br />
    summary = tf.Summary()<br />
    #pylint: disable=maybe-no-member<br />
    summary.value.add(tag='time/save_variables', simple_value=save_time_variables)<br />
    summary.value.add(tag='time/save_metagraph', simple_value=save_time_metagraph)<br />
    summary_writer.add_summary(summary, step)

def parse_arguments(argv):<br />
    '''<br />
    参数解析<br />
    '''<br />
    parser = argparse.ArgumentParser()

    #日志文件保存路径<br />
    parser.add_argument('--logs_base_dir', type=str,<br />
        help='Directory where to write event logs.', default='~/logs/facenet')<br />
    #模型文件保存路径<br />
    parser.add_argument('--models_base_dir', type=str,<br />
        help='Directory where to write trained models and checkpoints.', default='~/models/facenet')<br />
    #GOU内存分配指定大小(百分比)<br />
    parser.add_argument('--gpu_memory_fraction', type=float,<br />
        help='Upper bound on the amount of GPU memory that will be used by the process.', default=1.0)<br />
    #加载预训练模型<br />
    parser.add_argument('--pretrained_model', type=str,<br />
        help='Load a pretrained model before training starts.')<br />
    #经过MTCNN对齐和人脸检测后的数据存放路径<br />
    parser.add_argument('--data_dir', type=str,<br />
        help='Path to the data directory containing aligned face patches.',<br />
        default='~/datasets/casia/casia_maxpy_mtcnnalign_182_160')<br />
    #指定网络结构<br />
    parser.add_argument('--model_def', type=str,<br />
        help='Model definition. Points to a module containing the definition of the inference graph.', default='models.inception_resnet_v1')<br />
    #训练epoch数<br />
    parser.add_argument('--max_nrof_epochs', type=int,<br />
        help='Number of epochs to run.', default=500)<br />
    #指定batch大小<br />
    parser.add_argument('--batch_size', type=int,<br />
        help='Number of images to process in a batch.', default=90)<br />
    #指定图片大小<br />
    parser.add_argument('--image_size', type=int,<br />
        help='Image size (height, width) in pixels.', default=160)<br />
    #每一个epoch的batches数量<br />
    parser.add_argument('--epoch_size', type=int,<br />
        help='Number of batches per epoch.', default=1000)<br />
    #embedding的维度<br />
    parser.add_argument('--embedding_size', type=int,<br />
        help='Dimensionality of the embedding.', default=128)<br />
    #随机裁切？<br />
    parser.add_argument('--random_crop',<br />
        help='Performs random cropping of training images. If false, the center image_size pixels from the training images are used. ' +<br />
         'If the size of the images in the data directory is equal to image_size no cropping is performed', action='store_true')<br />
    #随即翻转<br />
    parser.add_argument('--random_flip',<br />
        help='Performs random horizontal flipping of training images.', action='store_true')<br />
    #随机旋转<br />
    parser.add_argument('--random_rotate',<br />
        help='Performs random rotations of training images.', action='store_true')<br />
    parser.add_argument('--use_fixed_image_standardization',<br />
        help='Performs fixed standardization of images.', action='store_true')<br />
    #弃权系数<br />
    parser.add_argument('--keep_probability', type=float,<br />
        help='Keep probability of dropout for the fully connected layer(s).', default=1.0)<br />
    #正则化系数<br />
    parser.add_argument('--weight_decay', type=float,<br />
        help='L2 weight regularization.', default=0.0)<br />
    #中心损失和Softmax损失的平衡系数<br />
    parser.add_argument('--center_loss_factor', type=float,<br />
        help='Center loss factor.', default=0.0)<br />
    #中心损失的内部参数<br />
    parser.add_argument('--center_loss_alfa', type=float,<br />
        help='Center update rate for center loss.', default=0.95)<br />
    parser.add_argument('--prelogits_norm_loss_factor', type=float,<br />
        help='Loss based on the norm of the activations in the prelogits layer.', default=0.0)<br />
    parser.add_argument('--prelogits_norm_p', type=float,<br />
        help='Norm to use for prelogits norm loss.', default=1.0)<br />
    parser.add_argument('--prelogits_hist_max', type=float,<br />
        help='The max value for the prelogits histogram.', default=10.0)<br />
    #优化器<br />
    parser.add_argument('--optimizer', type=str, choices=['ADAGRAD', 'ADADELTA', 'ADAM', 'RMSPROP', 'MOM'],<br />
        help='The optimization algorithm to use', default='ADAGRAD')<br />
    #学习率<br />
    parser.add_argument('--learning_rate', type=float,<br />
        help='Initial learning rate. If set to a negative value a learning rate ' +<br />
        'schedule can be specified in the file "learning_rate_schedule.txt"', default=0.1)<br />
    parser.add_argument('--learning_rate_decay_epochs', type=int,<br />
        help='Number of epochs between learning rate decay.', default=100)<br />
    parser.add_argument('--learning_rate_decay_factor', type=float,<br />
        help='Learning rate decay factor.', default=1.0)<br />
    parser.add_argument('--moving_average_decay', type=float,<br />
        help='Exponential decay for tracking of training parameters.', default=0.9999)<br />
    parser.add_argument('--seed', type=int,<br />
        help='Random seed.', default=666)<br />
    parser.add_argument('--nrof_preprocess_threads', type=int,<br />
        help='Number of preprocessing (data loading and augmentation) threads.', default=4)<br />
    parser.add_argument('--log_histograms',<br />
        help='Enables logging of weight/bias histograms in tensorboard.', action='store_true')<br />
    parser.add_argument('--learning_rate_schedule_file', type=str,<br />
        help='File containing the learning rate schedule that is used when learning_rate is set to to -1.', default='data/learning_rate_schedule.txt')<br />
    parser.add_argument('--filter_filename', type=str,<br />
        help='File containing image data used for dataset filtering', default='')<br />
    parser.add_argument('--filter_percentile', type=float,<br />
        help='Keep only the percentile images closed to its class center', default=100.0)<br />
    parser.add_argument('--filter_min_nrof_images_per_class', type=int,<br />
        help='Keep only the classes with this number of examples or more', default=0)<br />
    parser.add_argument('--validate_every_n_epochs', type=int,<br />
        help='Number of epoch between validation', default=5)<br />
    parser.add_argument('--validation_set_split_ratio', type=float,<br />
        help='The ratio of the total dataset to use for validation', default=0.0)<br />
    parser.add_argument('--min_nrof_val_images_per_class', type=float,<br />
        help='Classes with fewer images will be removed from the validation set', default=0)

    # Parameters for validation on LFW  检验参数<br />
    parser.add_argument('--lfw_pairs', type=str,<br />
        help='The file containing the pairs to use for validation.', default='data/pairs.txt')<br />
    #lfw数据集经过MTCNN进行人脸检测和对齐后的数据路径<br />
    parser.add_argument('--lfw_dir', type=str,<br />
        help='Path to the data directory containing aligned face patches.', default='')<br />
    parser.add_argument('--lfw_batch_size', type=int,<br />
        help='Number of images to process in a batch in the LFW test set.', default=100)<br />
    parser.add_argument('--lfw_nrof_folds', type=int,<br />
        help='Number of folds to use for cross validation. Mainly used for testing.', default=10)<br />
    parser.add_argument('--lfw_distance_metric', type=int,<br />
        help='Type of distance metric to use. 0: Euclidian, 1:Cosine similarity distance.', default=0)<br />
    parser.add_argument('--lfw_use_flipped_images',<br />
        help='Concatenates embeddings for the image and its horizontally flipped counterpart.', action='store_true')<br />
    parser.add_argument('--lfw_subtract_mean',<br />
        help='Subtract feature mean before calculating distance.', action='store_true')<br />
    return parser.parse_args(argv)

if __name__ == '__main__':<br />
    main(parse_arguments(sys.argv[1:]))</pre>
</div>
</div>
<ul><li>创建CNN网络，用于提取人脸特征；</li>
<li>训练数据准备阶段，采用TF队列机制加载数据集；</li>
<li>定义CNN网络损失函数，$L2$正则化、中心损失函数、交叉熵代价函数(严格来说是softmax损失函数)；</li>
<li>开始在数据集上训练、并在LFW上测试；</li></ul>
<h4>7、三元组损失和中心损失的定义</h4>
<p>最后我们来分析一下三元损失和中心损失的定义。</p>
<p>三元组损失的定义在文件src/facenet.py中，对应的函数为triplet_loss()：</p>
<div>
<pre class="prettyprint linenums">def triplet_loss(anchor, positive, negative, alpha):<br />
    """Calculate the triplet loss according to the FaceNet paper

    Args:<br />
      anchor: the embeddings for the anchor images.<br />
      positive: the embeddings for the positive images.<br />
      negative: the embeddings for the negative images.

    Returns:<br />
      the triplet loss according to the FaceNet paper as a float tensor.<br />
    """<br />
    with tf.variable_scope('triplet_loss'):<br />
        pos_dist = tf.reduce_sum(tf.square(tf.subtract(anchor, positive)), 1)<br />
        neg_dist = tf.reduce_sum(tf.square(tf.subtract(anchor, negative)), 1)

        basic_loss = tf.add(tf.subtract(pos_dist,neg_dist), alpha)<br />
        loss = tf.reduce_mean(tf.maximum(basic_loss, 0.0), 0)

    return loss</pre>
</div>
<p>输入的anchor、positive、negative分别为随机选取的人脸样本的特征、anchor的正样本特征、anchor的负样本特征，它们的形状都是[batch_size,feature_size]。batch_size很好理解，feature_size是网络学习的人脸特征的维数。对应到三元组损失的公式$L_i=[\|f(x_i^a)-f(x_i^p)\|_2^2+\alpha-\|f(x_i^a)-f(x_i^n)\|_2^2]_+$中的话，anchor每一行就是一个$x_i^a$，positive的每行就是相应正样本的$x_i^p$,negative每行就是负样本$x_i^n$。先来分别计算正样本和负样本到anchor的$L^2$距离。变量pos_dist就是anchor到各自正样本之间的距离$\|f(x_i^a)-f(x_i^p)\|_2^2$，变量neg_dist是anchor到负样本的距离$\|f(x_i^a)-f(x_i^n)\|_2^2$。接下来，用pos_dist减去neg_dist再加上一个$\alpha$，最终损失只计算大于0的这部分，这和公式$L_i$是完全一致的。</p>
<p>再来看一下中心损失的定义，同样是位于src/facenet.py中，对应的函数是center_loss()：</p>
<div>
<pre class="prettyprint linenums">def center_loss(features, label, alfa, nrof_classes):<br />
    """Center loss based on the paper "A Discriminative Feature Learning Approach for Deep Face Recognition"<br />
       (http://ydwen.github.io/papers/WenECCV16.pdf)<br />
    """<br />
    #nrof_features就是feature_size，即CNN计算得到的人脸的维数<br />
    nrof_features = features.get_shape()[1]

    #centers为变量，它是各个类别对应的类别中心<br />
    centers = tf.get_variable('centers', [nrof_classes, nrof_features], dtype=tf.float32,<br />
        initializer=tf.constant_initializer(0), trainable=False)

    label = tf.reshape(label, [-1])

    #根据label，取出features中每一个样本对应的类别中心<br />
    #centers_batch形状和features一致，[batch_size,feature_size]<br />
    centers_batch = tf.gather(centers, label)

    #计算类别中心和各个样本特征的差距diff<br />
    #diff用来更新各个类别中心的位置<br />
    #计算diff时用到的alfa是一个超参数，它可以控制中心位置的更新幅度<br />
    diff = (1 - alfa) * (centers_batch - features)

    #使用diff来更新中心<br />
    centers = tf.scatter_sub(centers, label, diff)

    #计算loss<br />
    with tf.control_dependencies([centers]):<br />
        loss = tf.reduce_mean(tf.square(features - centers_batch))

    #返回loss和更新后的中心<br />
    return loss, centers</pre>
</div>
<p>输入参数features是样本的特征，它的形状为[batch_size,feature_size]。label为这些样本各自的类别标签号(即属于哪个人，这里使用0,1,2,3...表示)，它的形状是[batch_size,]。alfa是一个超参数，它是0~1之间的一个浮点数。nrof_classes是一个整数，它表示全部训练集中样本的类别总数。</p>
<p>定义中心损失时，首先会根据各个样本的标签取出相应的类别中心center_batch、center_batch形状和feature完全一致，中心损失就是它们之间的$L^2$距离。这与之前我们介绍的中心损失函数公式$L_i=\frac{1}{2}\|f(x_i)-c_{yi}\|_2^2$只差一个比例系数。此外程序还会计算center_batch和feature的差值diff，根据diff来更新类别中心，超参数alfa可以控制更新时的幅值。</p>
<p><strong>参考文章：</strong></p>
<p><strong><a href="https://arxiv.org/pdf/1604.02878" rel="external nofollow noreferrer">[1]Joint Face Detection and Alignment using Multi-task Cascaded Convolutional Networks</a></strong></p>
<p><strong><a href="https://github.com/kpzhang93/MTCNN_face_detection_alignment" rel="external nofollow noreferrer">[2]官方代码</a></strong></p>
<p><strong><a href="https://github.com/pangyupo/mxnet_mtcnn_face_detection" rel="external nofollow noreferrer">[3]其他代码实现（MXNet）</a></strong></p>
<p><strong><a href="https://github.com/hzy46/Deep-Learning-21-Examples" rel="external nofollow noreferrer">[4]21个项目玩转深度学习 何之源(部分内容来自于该书，第六章，GitHub网址)</a></strong></p>
<p><strong><a href="http://www.sohu.com/a/149479111_505825" rel="external nofollow noreferrer">[5]如何通过OpenFace实现人脸识别框架</a></strong></p>
<p><strong><a href="http://www.uml.org.cn/ai/201806124.asp" rel="external nofollow noreferrer">[6]如何应用MTCNN和FaceNet模型实现人脸检测及识别(原理讲解还是比较细的)</a></strong></p>
<p><strong><a href="https://blog.csdn.net/FortiLZ/article/details/81396566" rel="external nofollow noreferrer">[7]MTCNN 的 TensorFlow 实现</a></strong></p>
<p><strong><a href="https://blog.csdn.net/xingwei_09/article/details/79161931" rel="external nofollow noreferrer">[8]人脸识别（Facenet）</a></strong></p>
<p><strong><a href="https://blog.csdn.net//chenriwei2/article/details/50631212" rel="external nofollow noreferrer">[9]【数据库】FaceDataset常用的人脸数据库</a></strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e0woxq.html">【转载】实时监听输入框值变化的完美方案：oninput &amp;amp&semi; onpropertychange</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7y32kq.html">Centos搭建SVN服务器三步曲</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxm3nj9.html">LeetCode【169&period; Majority Element】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e11p1x9.html">Jmeter java&period;lang&period;OutOfMemoryError&colon; GC overhead limit exceeded</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1dpkx8.html">创建xml时，设置xml编码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv057yq.html">&lbrack;Angular2 Form&rsqb; Use RxJS Streams with Angular 2 Forms</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mjxlxq.html">C&plus;&plus;Vector使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1p45dq.html">解决mysql中文乱码问题 在url后面添加&quest;characterEncoding&equals;utf8</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jgvxeq.html">Python爬虫入门之Urllib库的高级用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvn2z28.html">odoo11 model&plus;Recordset 基础未完待续</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjpkwz9.html">linux命令应用之一</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwze1x9.html">ftp服务器搭建流程详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2y1pv8.html">C&sol;C&plus;&plus;程序调试和内存检测</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnkkxdq.html">廖雪峰git教程学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/963gz649.html">Codeforces Round &num;256 &lpar;Div&period; 2&rpar; E  Divisors</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko7mr3q.html">flask代码统计作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koxe77q.html">PHP对象的遍历</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77ogzxq.html">vue基础知识之vue-resource&sol;axios</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwoldrr9.html">&commat;autoclosure-可以让表达式自动封装成一个闭包：输入的是一个表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jpjo08.html">前端面试题&lpar;copy&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ojzrz5q.html">&lbrack;Web&rsqb;&lbrack;DreamweaverCS6&rsqb;&lbrack;高中同学毕业分布去向网站&plus;服务器上挂载&rsqb;一、安装与破解DreamweaverCS6&plus;基本规划</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me37m0q.html">Jmeter设置代理，抓包之app请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd04wz9.html">导入JavaWeb 项目出现的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojzz1lq.html">如何删除windows中运行的历史记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpyykr9.html">requests的基本用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv166yoq.html">如何在Asp&period;Net中使用JQueryEasyUI</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1mpggq.html">Maven pom&period;xml中的元素modules、parent、properties以及import</a>
			</li>
						<li><a href="https://www.batexi.com/a/9506rxz8.html">SpringBoot实战&lpar;八&rpar;之RabbitMQ</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kemd09.html">TabBar用到bottomNavigationBar</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zxge59.html">Skyline 7 版本TerraExplorer Pro二次开发快速入门</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
